$(window).ready(function() {

    var parent_window = opener;

    if (parent_window === null) {
        invalidMessage('no parent window');
        return;
    }

    if (typeof parent_window.player.getFigure !== "function") {
        invalidMessage('parent.getFigure undefined');
        return;
    }

    var params = new URLSearchParams(window.location.search);
    if (!params.has('figid')) {
        invalidMessage('figid param does not exist');
        return; 
    }

    var figure = parent_window.player.getFigure(params.get('figid'));

    console.log(figure);

    if (figure.title) {
        $('title').html(figure.title + ' | Figure');
        $('h1').html(figure.title);
    }
    else {
        $('title').html('Figure');
        $('h1').html('Figure');
    }

    //$('img').attr('src', figure.src);
    $('img').attr('alt', figure.alt);
    $('figcaption').html(figure.caption);

    var img = new Image();
    img.onload = function () {
        var imgWidth = this.width;
        $('img').attr('src', img.src);
        $('main').css('max-width', imgWidth + 'px').css('display', 'block');
    }
    img.src = figure.src;

});

function invalidMessage(mesg) {
    $("main").html("");
    $("main").append("<h1>Unable to open</h1>");
    $("main").append("<p>Please go back and open this window "
        + "from the link in the activity.</p>");
    $('main').append('<p>' + mesg + '</p>')
}
