// add SAVI video player stylesheet
(function () {
    var video_head = document.getElementsByTagName('head')[0];
    var video_style = document.createElement('link');
    video_style.href = 'https://savi-cdn.macmillantech.com/fonts/SourceSansPro/sourceSansPro.css';
    video_style.type = 'text/css';
    video_style.rel = 'stylesheet';
    video_head.appendChild(video_style);
})();

// add custom SAVI CSS overrides to make responsive
(function () {
    var video_head = document.getElementsByTagName('head')[0];
    var video_style = document.createElement('link');
    video_style.href = 'asset/savi_video_local.css';
    video_style.type = 'text/css';
    video_style.rel = 'stylesheet';
    video_head.appendChild(video_style);
})();

function viewingInPx() {
    if (typeof window.PX !== 'undefined') {
        return true;
    }
    if (typeof window.parent.PX !== 'undefined') {
        return true;
    }
    return false;
}

routie('digfir_section_?:sec', function (sec) {
    sec = Number(sec);

    console.log('routie: sec = ', sec);
    console.log('routie: player.sections.length = ', player.sections.length);

    if (isNaN(sec) || sec < 0) {
        console.log('routie: invalid section number');
        return;
    }

    if (sec === 0) {
        console.log('routie: user can always view section 0');
        player.show_section(0, true);
        return;
    }

    if (player.sections.length > 0 && sec > (player.sections.length - 1)) {
        console.log('routie: section number exceeds number of sections');
        return;
    }

    if (!player || typeof player.canViewSection !== 'function') {
        console.log('routie: player.canViewSection not found');
        return;
    }

    // We don't need to do anything if we are already on this section
    if (sec === player.section_currently_showing) {
        console.log('routie: already on section ' + sec);
        return;
    }

    if (player.canViewSection(sec)) {
        // If we are using routie then we want to focus on the h2
        console.log('routie: routing to section ' + sec);
        player.show_section(sec, true);
    }
    else {
        console.log('routie: user does not have permission to view section ', sec);
    }
});


$('[data-type="section"]').removeAttr('level');

$('[http-equiv="X-UA-Compatible"]').remove();

(function ($) {
  $.fn.changeElementType = function (newType) {
    var attrs = {};

    $.each(this[0].attributes, function (idx, attr) {
      attrs[attr.nodeName] = attr.nodeValue;
    });

    this.replaceWith(function () {
      return $("<" + newType + "/>", attrs).append($(this).contents());
    });
  };
})(jQuery);

$('br.clear').remove();

$('h2.section-title').remove();

$('#manuscript').changeElementType('main');

$('div[data-type="question"]').each(function () {
    $(this).changeElementType('form');
});

$('[data-type="query_display"]').remove();

$('[data-type="query"]').each(function () {
    $(this).changeElementType('div');
});

$('[data-block_type="abbr"]').each(function () {
    $(this).changeElementType('abbr');
});

$('[data-block_type="cite"]').each(function () {
    $(this).changeElementType('cite');
});

$('[data-element]').each(function () {
    var $this = $(this);
    var el = $this.attr('data-element');
    $this.removeAttr('data-element');
    $this.changeElementType(el);
});

$('[data-label_for]').each(function () {
    var $this = $(this);
    var labelFor = $this.attr('data-label_for');
    this.setAttribute('for', labelFor);
    $this.removeAttr('data-label_for');
    $this.changeElementType('label');
});

$('[data-labelledby]').each(function () {
    var $this = $(this);
    var id = $this.attr('data-labelledby');
    $this.attr('aria-labelledby', id);
});

$('h3[data-for_type="box"]').each(function () {
    var $this = $(this);
    if ($this.text() === '') {
        $this.remove();
    }
});


var secCounter = 0;
$('[data-type="section"]').each(function () {
    $this = $(this);
    $this.attr('aria-labelledby', 'sec' + secCounter + 'h2');
    secCounter++;
    $this.changeElementType('article');
});

var Activity_subtype = Activity_manuscript_type = Activity.extend({

    ARGA_initialization_alert: function () {
        // This overrides the standard ARGA initialization message, which doesn't
        // tell the user he/she can resubmit (or tell him his grade)
        var grade = Get_ARGA_Grade();
        var due_date_passed = (Get_ARGA_Data("due_date_has_passed") == "1");
        var msg = "";
        var buttons;
        var modalTitle = "Please Note";

        due_date_passed = false;

        if (grade != "" && grade != null && grade >= 0) {
            // if resubmissions are allowed...
            if (player.md.allow_resubmission == "true") {
                // if due date has not passed, give the student the option of resubmitting or reviewing
                if (!due_date_passed) {
                    msg = "<p>You have completed this activity, and your grade (" + grade + "%) has been submitted. Would you like to:</p><ul>"
                        + "<li><b>Keep your current grade</b> and review your previous answers</li>"
                        + "<li>Or reset your submission and <b>try the activity again</b>?</li>"
                        + "</ul>"
                        ;
                    buttons = [{ text: "Keep current grade", click: player.activity.ARGA_initialization_final }
                        , { text: "Try Activity Again", click: function () { player.activity.ARGA_initialization_final("reset") } }
                    ];

                } else {
                    msg = "<p>You have completed this activity, and your grade (" + grade + "%) has been submitted. Since the due date for the activity has now passed, you cannot re-submit answers to the activity questions.</p>"
                    buttons = [{ text: "OK", click: player.activity.ARGA_initialization_final }];
                }

                // resubmissions are not allowed
            } else {
                msg = "You have completed this activity. Please check the gradebook for your final grade.";
                modalTitle = "Activity Completed"
                buttons = [{ text: "OK", onClick: player.activity.ARGA_initialization_final }];
            }

            // grade has not been submitted
        } else {
            // if due date has passed, tell the user "tough luck". Otherwise show nothing.
            if (due_date_passed) {
                msg = "The due date for this activity has passed.  You can still review the activity, but no answers will be submitted and no grade will be recorded.";
                modalTitle = "Due Date Has Passed"
                buttons = [{ text: "OK", onClick: player.activity.ARGA_initialization_final }];
            }
        }

        // if we need a message, show it in a jquery UI dialog
        if (msg != "") {
            ARIAmodal.openModal(
                {
                    modalId: 'aria_modal',
                    top: player.getModalTop(),
                    title: modalTitle,
                    text: msg,
                    buttons: buttons,
                    closeFocus: 'banner_activity_title'
                }
            );
        }
        else {
            player.activity.ARGA_initialization_final();
        }
    },

    add_question: function (index, element) {
        var a = player.activity;	// this fn gets called within the scope of a jquery each, so we can't refer to "this"

        var jq = $(element);

        // see if we're in a question_pool or question_sequence block
        var qs_parent = jq.parents("[data-block_type=question_sequence], [data-block_type=question_sequence_one_at_a_time]");

        var q = a.questions[a.questions.length] = new Question({
            "index": a.questions.length
            , "number": jQuery.trim($("[data-type='number']", jq).html())
            , "title": jQuery.trim($("[data-type='title']", jq).html())
            , "jq": jq
            , "points_possible": 0
        });

        // store the question index in the DOM too
        jq.attr("data-question_index", q.index);

        // get question queries		
        a.question_being_initialized = q;
        $("[data-type='query']", jq).each(a.add_query);

        // if the question has queries, add bling to the bottom
        if (q.queries.length > 0) {


            var html = "<div class='question_error_div' id='question_error_div_" + q.index + "'></div>";

            html += "<div class='question_action_div' id='question_action_div_" + q.index + "'>";

            var submit_handler;
            // add a submit button if we're supposed to have one
            // (image map and matching questions, which should contain one and only one query, don't have submit buttons)
            if (q.queries[0].hasSubmitButton === true) {
                // "answer_one" pool mode (yet to be fully implemented...)
                if (q.pool_mode == 'answer_one') {
                    html += "<input class='standard_button question_submit_button' type='button' id='question_submit_button_" + q.index + "' value='Answer This Query' />";
                    submit_handler = player.activity.Show_Submit;

                } else {
                    html += a.question_submit_button(q);
                    submit_handler = player.activity.submit_question;
                }
            }

            // add a "give up" button if we're supposed to have one
            // (image map questions, which should contain one and only one query, should have this button)
            if (q.queries[0].hasGiveUpButton === true) {
                html += "<input class='standard_button question_submit_button' type='button' id='question_submit_button_" + q.index + "' value='Give Up' />";
                submit_handler = player.activity.give_up_question;
            }

            html += "</div>";

            jq.append(html);

            // bind the submit_handler function to the button, passing in the question_index
            $("#question_submit_button_" + q.index).click({ question_index: q.index }, submit_handler);

            // float instructor controls to right of action button
            jq.prepend(a.instructor_question_controls(q));

            // also, determine question points and weight at this time
            for (var i = 0; i < q.queries.length; ++i) {
                q.points_possible += q.queries[i].getPointsPossible();
            }
            // round to two decimal places, in case there are decimals
            q.points_possible = Math.round(q.points_possible * 100) / 100;
        }

        // now that the question has been created, deal with sequences and pools
        if (qs_parent.length > 0) {
            // get sequence index and item
            var qs_index = qs_parent.attr("question_sequence_index") * 1;
            var qs = a.question_sequences[qs_index];

            // place in sequence
            var sequence_num = qs.questions.length;
            qs.questions[sequence_num] = q;

            // place reference to sequence in question
            q.question_sequence = qs;
            q.question_sequence_index = sequence_num;

            // if this isn't #1, hide the question
            if (sequence_num > 0) {
                jq.hide();
            }

            // update the sequence navigator if it's there
            $("#question_sequence_max_index_" + qs.index).html(sequence_num + 1);
        }

        // Adjust heading
        var metadata = player.activity.questions[q.index].md;
        var $heading = $('[data-question_index="' + q.index + '"]').find('h3');
        if (metadata.question_number) {
            $heading.text('Question ' + metadata.question_number);
        }
        else {
            $heading.text('Question');
        }

        if (metadata.heading_hidden === 'true') {
            $heading.addClass('visually-hidden');
        }

        if (metadata.heading_level) {
            $heading.changeElementType('h' + metadata.heading_level);
        }

    },

    question_submit_button: function (q) {
        // define question_submit_button_label as a variable so it can be overridden
        var button_html = "<button class='standard_button question_submit_button' id='question_submit_button_"
            + q.index
            + "'>Submit<span class='visually-hidden'>, Question "
            + q.index
            + "</span></button>";
        return button_html;
    },

    show_grade_saved_message: function () {
        // if the user has answered all queries AND the user hasn't been told
        // this already, tell them now
        if (player.activity.answered_all_queries && !player.user_has_received_completion_alert) {
            //setTimeout('Standard_Dialog.alert("You have completed the activity, and your grade has been submitted.");', 20);
            player.user_has_received_completion_alert = true;
        }
    },

    submit_question: function (question_index) {

        // The submit button handler is killing the click event and thus 
        // we need to manually close the outline menu if it is open because
        // the event is not reaching document.
        player.closeOutlineMenu();

        let event;

        if (typeof question_index == "object") {
            // question_index is actually the event object and we need 
            // save it off so we can stop propagation later on if
            // needed
            event = question_index;
            // extract the question_index from the object
            question_index = question_index.data.question_index;
        }

        var query = player.activity.questions[question_index].queries[0];

        if (query.getQueryTypeForARGA() === 'drop-down') {
            var userAnswer = $('#query_answer_' + query.query_index).val();
            if (Number(userAnswer) < 0) {
                var errMesg = player.activity.questions[question_index].md.input_error || 'Error!';
                query.setError(errMesg);
                AriaText.setLiveText(errMesg);
                return false;
            }
            else {
                query.clearError(errMesg);
            }
        }
        else if (query.getQueryTypeForARGA() === 'essay') {
            var userAnswer = $('#query_answer_' + query.query_index).val().trim();
            if (userAnswer === "") {
                var errMesg = "You must enter an answer before submitting."
                query.setError(errMesg);
                AriaText.setLiveText(errMesg);
                return false;
            }
            else {
                query.clearError(errMesg);
            }
        }

        event.preventDefault();
        event.stopPropagation();

        if (query.getQueryTypeForARGA() === 'essay') {
            
            ARIAmodal.openModal(
                {
                    modalId: 'aria_modal',
                    top: player.getModalTop(),
                    title: 'Verify Submission',
                    text: 'Do you want to submit your answer? You will not be able to edit your answer after submitting.',
                    buttons: [
                        {
                            text: 'Cancel', onClick: function () {
                                player.setFocus('question_submit_button_' + question_index);
                            }
                        },
                        {
                            text: 'Submit', onClick: function () {
                                player.activity.submit_question_go(question_index);
                            }
                        }
                    ],
                    closeFocus: 'question_submit_button_' + question_index
                }
            );

            return;

        }
        else {
            player.activity.submit_question_go(question_index);
        }
    },

    submit_question_go: function (question_index) {

        // the arg may be a number or an event object; in the latter case...
        if (typeof question_index == "object") {
            // extract the question_index from the object
            question_index = question_index.data.question_index;
        }

        var t = player.activity;

        var question = t.questions[question_index];

        var all_answers_correct = true;
        // for each query in the question...
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];

            // evaluate the answer. If evaluateAnswer returns false, the answer isn't submittable at this time -- 
            // most likely because it's a free-response answer that needs to be evaluated via MAVE.
            var answer_submittable = query.evaluateAnswer(question_index);
            if (answer_submittable === false) {
                // as soon as we get an unsubmittable answer, we return. submit_question
                // will be called again, either by the callback fn of MAVE or because the student
                // resubmits. At that point we'll catch any additional free-response answers that need
                // checking, or we'll finish this loop here and move on.
                return;
            }
            all_answers_correct = all_answers_correct && query.isCorrect();
        }

        // if we made it to here, we're at least going to show which items are correct and incorrect
        // we might overwrite with review mode below, but that's OK
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];
            query.jq.html(query.getHTML("review_correct_incorrect"));
        }

        // update question tries
        ++question.tries;

        // if answer is incorrect, and max_tries is set, and # of tries is less than max_tries
        // (and the user didn't just give up)
        if ((!all_answers_correct && question.md.max_tries != null && question.tries < question.md.max_tries) && question.gave_up != true) {
            // tell user he can try again
            t.show_question_feedback(question, false, true);
            return;
        } else {
            t.show_question_feedback(question, all_answers_correct, false);
        }

        $('#question_feedback_' + question_index).focus();

        // if we make it to here we need to set ARGA info for the question, and show queries in review mode
        // if md.question_report_text is set, we submit the question as a whole, rather than as individual queries
        var query_correct_answers = "";
        var query_responses = "";
        var query_responses_for_questionData = "";
        var query_grade_sum = 0;
        // for each query in the question...
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];

            // establish a question number to use
            var query_number = t.get_query_number(question, i);

            // get a query weight
            var query_weight = question.get_weight();
            // if the question has more than one query, divide weight accordingly
            if (question.queries.length > 1) {
                query_weight = Math.round(query_weight / question.queries.length);
            }

            // if credit_after_max_tries is set, give at least that credit now, as long as the student tried
            if (question.md.credit_after_max_tries != null) {
                var query_grade = query.getGradeForARGA();
                if (query_grade >= 0 && query_grade < question.md.credit_after_max_tries) {
                    query.overrideGrade(question.md.credit_after_max_tries * 1);
                }
            }

            // set the ARGA response, unless we're saving one response for the whole question
            if (!question.md_set("question_report_text")) {
                t.ARGA_set_query_response(query, query_number, query_weight);

                // otherwise compose query roll-ups
            } else {
                if (query_correct_answers != "") {
                    query_correct_answers += " / ";
                    query_responses += " / ";
                    query_responses_for_questionData += t.query_responses_separator;
                }
                query_correct_answers += query.getCorrectAnswerForARGA();
                query_responses += query.getUserAnswerForARGA();
                // see restore_saved_answers for how this is used later
                query_responses_for_questionData += query.getUserAnswerForARGA()
                    + t.query_responses_grade_separator
                    + query.getOriginalGrade();
                query_grade_sum += query.getGradeForARGA() * 1;
            }

            // show in review mode, unless question metadata says not to show correct answers
            if (question.md.show_correct_answers != "false") {
                query.jq.html(query.getHTML("review"));
            }
        }

        // if we're saving one response for the whole question, save here
        if (question.md_set("question_report_text")) {
            var question_grade = Math.round(query_grade_sum / question.queries.length);
            t.ARGA_set_question_response(question, query_correct_answers, query_responses, question_grade, query_responses_for_questionData);
        }

        // grade the activity
        t.grade_activity();

        // then if ARGA is running, submit data; show_grade_saved_message will be called on completion.
        if (player.ARGA_running) {
            t.ARGA_submit_data();
        }

        // update the question_action_div
        t.update_question_action_div(question_index);

        // if the item is in a sequence, show the next question
        t.show_next_question(question);

        // update section status
        player.update_section_status();

        var s = player.get_current_section();

        // if all questions are answered and all sequences are complete
        // (these are set by _super)
        if (s.all_questions_answered && s.all_question_sequences_completed) {
            // if we're not on the final step
            if (s.index < player.sections.length - 1) {
                // then show the buttona
                //UI_Elements.toggle_button("step_button", true);
                $('#step_link').attr('aria-disabled', 'false');

                // otherwise we're done!
            }
            else {
                player.show_completion_message();
            }
        }

        player.update_navigation();

        player.updateFinalReport();

        // focus on question feedback
        /*
        setTimeout(function () {
            $('#question_feedback_' + question_index).focus();
        }, 250);
        */
    },

    update_question_action_div: function (question_index) {
        var question = this.questions[question_index];

        // calculate points_awarded and points_possible
        var points_awarded = 0;
        var points_possible = 0;
        var points_provisional = false;
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];
            points_awarded += query.getPointsAwarded();
            points_possible += query.getPointsPossible();
            if (query.pointsAreProvisional() == true) {
                points_provisional = true;
            }
        }

        // round to at most two decimal places
        points_awarded = Math.round(points_awarded * 100) / 100;
        points_possible = Math.round(points_possible * 100) / 100;

        // hide submit button (and any other similar buttons that might be added by subtypes), but show points earned
        var jq = $("#question_action_div_" + question.index);
        //jq.find(".question_submit_button").hide();
        jq.find(".question_submit_button").remove();
        var points_html = "<div class='points_awarded_div'>Points awarded: " + points_awarded + " out of " + points_possible;

        if (points_provisional) {
            points_html += " (<a href='javascript:player.activity.explain_provisional()'>provisional</a>)";
        }
        points_html += "</div>";

        var jq = $("#question_action_div_" + question.index);
        jq.find(".points_awarded_div").remove();
        if (jq.find(".question_feedback").length > 0) {
            jq.find(".question_feedback").after(points_html);
        } else {
            jq.prepend(points_html);
        }
    },

    show_question_feedback: function (question, is_correct, try_again) {
        // remove prior feedback if there
        $("#question_feedback_" + question.index).remove();

        // if we don't have any feedback at all, return
        if (question.md.feedback == null && question.md.feedback_correct == null && question.md.feedback_incorrect == null && question.md.feedback_hint == null) {
            return;
        }

        var fbHeadingLevel = question.md.heading_level ? (Number(question.md.heading_level) + 1) : 4;

        var html = "<div class='question_feedback' id='question_feedback_" + question.index + "' tabindex='-1'>"
            + "<h" + fbHeadingLevel + " class='question_feedback_head'>" + this.feedbackTitle + "</h" + fbHeadingLevel + ">";

        var sr_fb = question.md.feedback_sr ? " <span class='visually-hidden'>" + question.md.feedback_sr + "</span>" : "";
        
        // include general feedback if there
        if (question.md.feedback != null) {
            html += "<div class='question_feedback_part'>" + question.md.feedback + sr_fb + "</div>";
        }

        // include correct feedback if there and the answer is correct
        if (is_correct && question.md.feedback_correct != null) {
            html += "<div class='question_feedback_part'>" + question.md.feedback_correct + "</div>";
        }

        // include incorrect or hint feedback if there and the answer is incorrect
        if (!is_correct) {
            var found_feedback_string = false;
            // if user gets to try again...
            if (try_again) {
                // check for feedback_conditional's
                if (question.md.feedback_conditional.length > 0) {
                    for (var i in question.md.feedback_conditional) {
                        var fbc = question.check_conditional(question.md.feedback_conditional[i]);
                        if (fbc != "") {
                            html += "<div class='question_feedback_part'>" + fbc + "</div>";
                            found_feedback_string = true;
                            break;
                        }
                    }
                }

                // if we didn't find a feedback string to use above, check for feedback_hint
                if (!found_feedback_string && question.md.feedback_hint != null) {
                    html += "<div class='question_feedback_part'>" + question.md.feedback_hint + "</div>";
                    found_feedback_string = true;
                }
            }

            // if we didn't find a feedback string to use above, check for feedback_incorrect
            if (!found_feedback_string && question.md.feedback_incorrect != null) {
                html += "<div class='question_feedback_part'>" + question.md.feedback_incorrect + "</div>";
            }
        }

        // close question_feedback div
        html += "</div>";

        // append the div, then fade it in
        $("#question_action_div_" + question.index).prepend(html);
        $("#question_feedback_" + question.index).fadeIn("fast", function () {
            // What I'd like to do here is check to make sure the feedback is all showing on the screen,
            // and scroll if necessary so that the feedback is all visible. But just doing "scrollTo"
            // isn't working properly in all situations.
            // $(window).scrollTo($(this), 0);
        });
    },

});


var Player_subtype = Player_manuscript_type.extend({

    FIRST_SHOW_SECTION: true,

    canViewSection: function (num) {
        // section we want to move to
        var secNum = Number(num);

        if (isNaN(secNum) || secNum < 0 || (secNum > player.sections.length - 1)) {
            return false;
        }
        if (player.isInstructor()) {
            return true;
        }
        // We can always move to a section that is less than/equal to our
        // last available section
        if (typeof player.last_available_section === 'number') {
            if (secNum <= player.last_available_section) {
                return true;
            }
            else {
                console.log('canViewSection: requested section ' + secNum + ' is greater than last available section ' + player.last_available_section);
                return false;
            }
        }
        // We can always move backwards 
        if (typeof player.section_currently_showing === 'number') {
            if (secNum <= player.section_currently_showing) {
                return true;
            }
        }

        console.log('canViewSection: can\'t verify permissions');
        return false;
    },

    isInstructor: function () {

        if (player.ARGA_running && Get_ARGA_Data('user_rights') === '3_instructor') {
            return true;
        }
        else if (!player.ARGA_running) {
            try {
                const params = new URLSearchParams(window.location.search);
                if (params.has('instructor') && params.get('instructor') === 'true') {
                    return true;
                }
            }
            catch (e) { }
        }
        return false;
    },

    printSummary: function () {
        var win = window.open('asset/psp_summary.html', 'printwindow');
    },

    getQuestionAnswer: function (question_number) {
        var question = player.activity.questions[question_number];
        if (!question.is_complete()) {
            return "<p>Question not answered.</p>";
        }

        return "<p>" + question.queries[0].getUserAnswerForARGA(); + "</p>";
    },

    updateFinalReport: function () {
        var $pspDiv = $('#your_psp');
        var headingBegin = "<h4>";
        var headingEnd = "</h4>";
        var userAnswer;
        var questions = player.activity.questions;

        var html = "<h3>Your Personal Success Plan</h3>";

        html += headingBegin + "Chapter" + headingEnd;
        userAnswer = questions[1].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Identify a Goal" + headingEnd;
        userAnswer = questions[2].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Make Your Goal SMART" + headingEnd;
        userAnswer = questions[3].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Create an Action Plan" + headingEnd;
        userAnswer = questions[4].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "List Barriers and Solutions" + headingEnd;
        userAnswer = questions[5].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Connect to Career" + headingEnd;
        userAnswer = questions[6].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        $pspDiv.html(html);
    },

    setFocus: function (arg) {
        if (typeof arg === 'string') {
            arg = document.getElementById(arg);
        }
        setTimeout(function () {
            try {
                arg.focus();
            }
            catch (err) {
                console.log('setFocus: ' + err.message);
            }
        }, 250);
    },

    getModalTop: function () {
        var fneContent = window.parent.document.getElementById('fne-content');
        if (fneContent === null || fneContent === undefined) {
            return undefined;
        }
        var fneHeight = fneContent.clientHeight;
        var scrollTop = fneContent.scrollTop;
        return scrollTop + (fneHeight / 2);
    },

    show_navigation: function () {
        
        // add <header> before <main>
        var header = "<header id='top_banner'>";

        /*
        if (this.activity_thumbnail_src != null) {
            header += "<img id='banner_thumbnail' src='" + this.activity_thumbnail_src + "' />";
        }
        */

        header += /*"<div id='banner_activity_type'>" + this.md.activity_type_title + "</div>"
            +*/ "<h1 id='banner_activity_title' tabindex='-1'>" + this.activity_title + "</h1>"
            + "</header>"	// top_banner
            ;

        $('main').before(header);
        $('h1.section-title').remove();
        
        var nav = "";

        if (this.sections.length > 1 && this.md.hide_toolbar != "true") {
            nav += "<nav id='toolbar'>"

                + "<div id='controls'>"

                /*
                + "<td>" + UI_Elements.get_button_html({
                    id: "contents_button",
                    extra_class: "toolbar_button",
                    label: "Contents", 
                    fn: 'player.show_toc()'
                }) + "</td>"
                */

                + "<div>" + UI_Elements.get_button_html({
                    id: "previous_button",
                    extra_class: "toolbar_button prev_next_buttons",
                    label: "Previous",
                    fn: 'player.show_section("previous")'
                }) + "</div>"


                + "<div>" + UI_Elements.get_button_html({
                    id: "slide_number",
                    extra_class: "toolbar_button",
                    label: "1 of " + this.sections.length,
                    fn: 'player.show_toc()'
                }) + "</div>"

                + "<div>" + UI_Elements.get_button_html({
                    id: "next_button",
                    extra_class: "toolbar_button prev_next_buttons",
                    label: "Next",
                    fn: 'player.show_section("next")'
                }) + "</div>"

                + "</nav>";	// controls

            //$('main').before(nav);
            
            $('main').before(this.create_nav_menu());


            /*
            $('#nav_prev_link').click(function () {
                if (player.section_currently_showing === 0) {
                    return;
                }
                player.show_section(player.section_currently_showing - 1);
            });

            $('#nav_next_link').click(function () {
                if (player.last_available_section > player.section_currently_showing && player.showing_last_section() === false) {
                    player.show_section(player.section_currently_showing + 1);
                }
            });
            */

            $('#nav_toc_button').click(function (e) {
                e.preventDefault();
                e.stopPropagation();

                var $button = $(this);
                var expanded = $button.attr('aria-expanded') === 'true';
                if (expanded) {
                    player.closeOutlineMenu();
                    /*
                    document.removeEventListener('click', player.nav_click_listener);
                    document.removeEventListener('keyup', player.nav_keyup_listener);
                    $button.attr('aria-expanded', 'false');
                    */
                }
                // This is the only place we add these event listeners
                else {
                    document.addEventListener('click', player.nav_click_listener);
                    document.addEventListener('keyup', player.nav_keyup_listener);
                    $button.attr('aria-expanded', 'true');
                }
                return false;
            });

            $('#nav_toc_submenu').click(function (e) {
                console.log('nav_toc_submenu.click')

                e.preventDefault();
                e.stopPropagation();

                if (e.target.tagName.toUpperCase() !== "A") {
                    return false;
                }

                var targetSec = Number($(e.target).attr('href').replace(/#digfir_section_/, ''));
                // we can always go backwards
                if (targetSec < player.section_currently_showing) {
                    $('#nav_toc_button').attr('aria-expanded', 'false');
                    player.show_section(targetSec, true);
                }
                // can we go forward?
                else if (targetSec > player.section_currently_showing) {
                    if (player.last_available_section >= targetSec || player.isInstructor()) {
                        $('#nav_toc_button').attr('aria-expanded', 'false');
                        player.show_section(targetSec, true);
                    }
                }
                return false;
            });

            /*
            var html = 
                + "<div id='slide_title'></div>"

                + "</div>"	// toolbar
                ;
            */
            
        }


        $('#manuscript').after('<nav id="slide_nav" aria-label="Slide"><a href="#" id="nav_prev_link" aria-disabled="true" aria-label="Previous slide"><span id="nav_prev_link_icon"><svg aria-hidden="true" focusable="false" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><g data-name="Layer 2"><g data-name="arrow-circle-left"><rect width="24" height="24" transform="rotate(90 12 12)" opacity="0"></rect><path d="M22 12a10 10 0 1 0-10 10 10 10 0 0 0 10-10zm-11.86 3.69l-2.86-3a.49.49 0 0 1-.1-.15.54.54 0 0 1-.1-.16.94.94 0 0 1 0-.76 1 1 0 0 1 .21-.33l3-3a1 1 0 0 1 1.42 1.42L10.41 11H16a1 1 0 0 1 0 2h-5.66l1.25 1.31a1 1 0 0 1-1.45 1.38z"></path></g></g></svg></span>Prev</a>' +
            
            '<div id="slide_number" aria-hidden="true"><span id="curr_slide"></span></div>' +
            
            '<a href="#digfir_section_1" id="nav_next_link" aria-disabled="false" aria-label="Next slide">Next<span id="nav_next_link_icon"><svg aria-hidden="true" focusable="false" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><g data-name="Layer 2"><g data-name="arrow-circle-right"><rect width="24" height="24" transform="rotate(-90 12 12)" opacity="0"></rect><path d="M2 12A10 10 0 1 0 12 2 10 10 0 0 0 2 12zm11.86-3.69l2.86 3a.49.49 0 0 1 .1.15.54.54 0 0 1 .1.16.94.94 0 0 1 0 .76 1 1 0 0 1-.21.33l-3 3a1 1 0 0 1-1.42-1.42l1.3-1.29H8a1 1 0 0 1 0-2h5.66l-1.25-1.31a1 1 0 0 1 1.45-1.38z"></path></g></g></svg></span></a>');

        
        $('#nav_prev_link').click(function (e) {
            var $link = $(this);
            var href = $link.attr('href');

            console.log('nav_prev_link click: ', $link, href);
            
            if (!(/#digfir_section_\d+/.test(href))) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }

            console.log('nav_prev_link click: returning true');
            return true;
        });

        $('#nav_next_link').click(function (e) {
            var $link = $(this);
            var href = $link.attr('href');

            console.log('nav_next_link click: ', $link, href);

            if (!(/#digfir_section_\d+/.test(href))) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }

            console.log('nav_next_link click: returning true');
            return true;
        });
        

    },

    create_nav_menu: function () {
        
        var nav = '<nav id="toolbar" aria-labelledby="nav_toc_button"><div id="controls">';

        nav += '<button id="nav_toc_button" aria-expanded="false" aria-controls="nav_toc_submenu"><svg focusable="false" aria-hidden="true" viewBox="0 0 18 18" xmlns="http://www.w3.org/2000/svg"><path d="M17 5H1a1 1 0 0 1 0-2h16a1 1 0 0 1 0 2zm0 5H1a1 1 0 0 1 0-2h16a1 1 0 0 1 0 2zm0 5H1a1 1 0 0 1 0-2h16a1 1 0 0 1 0 2z"/></svg><span>Outline</span></button><ul id="nav_toc_submenu">';

        for (var i = 0; i < player.sections.length; i++) {
            var $sec = $('#digfir_section_' + i);
            var $heading = $sec.find('[data-heading="h2"]');
            nav += '<li><a href="#digfir_section_' + i + '"><span class="visually-hidden">Slide ' + (i + 1) + ', </span>' + $heading.text() + '</a></li>';
        }

        nav += '</ul></div></nav>';

        return nav;
    },

    show_section: function (section_to_show, focus_h2) {

        console.log('show_section: ', section_to_show, focus_h2);

        var direction = "right";
        if (section_to_show == "previous") {
            section_to_show = this.section_currently_showing - 1;
            direction = "left";
        } else if (section_to_show == "next") {
            section_to_show = this.section_currently_showing + 1;
        }

        if (section_to_show == null || isNaN(section_to_show) || section_to_show < 0 || section_to_show >= this.sections.length) {
            return;
        }

        // if user has to view sections in sequence and hasn't gotten up to this one, don't allow it
        // brb: We are making this check elsewhere and don't need to show
        // these pop-up messages any more.
        if (this.md.sequenced_sections == "true" && section_to_show > this.last_available_section) {
            // but let instructors through
            if (player.activity.is_instructor()) {
                /*
                Standard_Dialog.alert("Please note: Students need to read and complete each section of the activity before moving on to the next section.  Instructors, however, can skip around between sections as they choose.");
                */
            } else {
                //Standard_Dialog.alert(this.md.section_sequence_message);
                return;
            }
        }

        this.show_section_animate(section_to_show, direction);

        // process iframes for the section, unless all were preloaded
        if (player.md.preload_all_iframes != "true") {
            this.figures.process_iframes(this.get_current_section().jq);		// iframes
        }

        this.update_section_status();

        $('#step_link').attr('href', '#digfir_section_' + (Number(player.section_currently_showing) + 1));

        // brb: set a small delay here so that screen reader does not
        // announce "unavailable" on Prev/Next links
        setTimeout(function () {
            player.update_navigation();
            if (focus_h2 && !player.FIRST_SHOW_SECTION) {
                $('#sec' + player.section_currently_showing + 'h2').focus();
            }
            else {
                player.FIRST_SHOW_SECTION = false;
            }
            // force resize on LP iframe
            try {
                parent.PX.API.Content.ResetHeight()
            }
            catch (e) {}
        }, 100);

        player.updateFinalReport();
    },

    update_navigation: function () {

        // show/hide the bottom "next" button as appropriate
        if (this.last_available_section > this.section_currently_showing && this.showing_last_section() === false) {
            $('#step_link').attr('aria-disabled', 'false');
        }
        else if (player.isInstructor()) {
            $('#step_link').attr('aria-disabled', 'false');
        }
        else {
            $('#step_link').attr('aria-disabled', 'true');
        }

        if (this.showing_last_section() && player.activity.answered_all_queries) {
            player.show_completion_message();
        }


        // main nav

        // prev link
        if (this.section_currently_showing === 0) {
            $('#nav_prev_link').attr('aria-disabled', 'true').attr('href', '#');
        }
        else {
            $('#nav_prev_link').attr('aria-disabled', 'false').attr('href', '#digfir_section_' + (this.section_currently_showing - 1));
        }

        // next link
        if (this.section_currently_showing < (player.sections.length - 1)) {
            $('#nav_next_link').attr('aria-disabled', 'false').attr('href', '#digfir_section_' + (this.section_currently_showing + 1));
            if (!player.canViewSection(this.section_currently_showing + 1)) {
                $('#nav_next_link').attr('aria-disabled', 'true');
            }
        }
        /*
        if ((this.last_available_section > this.section_currently_showing || player.isInstructor()) && this.showing_last_section() === false) {
            $('#nav_next_link').attr('aria-disabled', 'false').attr('href', '#digfir_section_' + (this.section_currently_showing + 1));
        }
        */
        else {
            $('#nav_next_link').attr('aria-disabled', 'true').attr('href', '#');
        }

        // toc
        player.closeOutlineMenu();
        /*
        $('#nav_toc_button').attr('aria-expanded', 'false');
        document.removeEventListener('click', player.nav_click_listener);
        document.removeEventListener('keyup', player.nav_keyup_listener);
        */

        $('#nav_toc_submenu').find('a').each(function () {
            var $link = $(this);
            var sec = $link.attr('href').replace(/[^\d]+/, "");
            
            if (player.last_available_section >= Number(sec) || player.isInstructor()) {
                $link.attr('aria-disabled', 'false');
            }
            else {
                $link.attr('aria-disabled', 'true');
            }

            if (player.section_currently_showing === Number(sec)) {
                $link.attr('aria-current', 'page');
            }
            else {
                $link.removeAttr('aria-current');
            }
        });

    },

    /* Listens for clicks on the page outside of the toc menu and 
        closes the menu. This handler should be attached to document. */
    nav_click_listener: function (e) {
        console.log('nav_click_listener(): ', e.target);

        /* The nav menu has its own listener which will catch any clicks on 
           it and stop the event from propagating. So the only clicks this
           should catch are any outside of the menu and thus we should just
           close the menu. */

        player.closeOutlineMenu();

        /*
        if (e.target.tagName.toUpperCase() !== "A" &&
            e.target.tagName.toUpperCase() !== "BUTTON" &&
            e.target.parentNode.id !== "nav_toc_submenu" &&
            e.target.parentNode.id !== "nav_toc_button") {
            document.removeEventListener('click', player.nav_click_listener);
            document.removeEventListener('keyup', player.nav_keyup_listener);
            $('#nav_toc_button').attr('aria-expanded', 'false');
        }
        */
    },

    closeOutlineMenu: function () {
        // This doesn't seem to cause a problem if executed when these 
        // handlers aren't actually listening on document.
        document.removeEventListener('click', player.nav_click_listener);
        document.removeEventListener('keyup', player.nav_keyup_listener);
        $('#nav_toc_button').attr('aria-expanded', 'false');
    },

    nav_keyup_listener: function (e) {
        var nav = document.getElementById('controls');
        var target = e.target;
        
        // Handle Esc if target is in the nav menu (close menu)
        if (e.key.toUpperCase() === "ESCAPE" && nav.contains(target)) {
            e.preventDefault();
            player.closeOutlineMenu();
            /*
            document.removeEventListener('click', player.nav_click_listener);
            document.removeEventListener('keyup', player.nav_keyup_listener);
            $('#nav_toc_button').attr('aria-expanded', 'false').focus();
            */
            return false;
        }

        // If this isn't the Tab key then we don't care
        if (e.key.toUpperCase() !== "TAB") {
            return;
        }
        
        // If Shift/Tab then close menu if target isn't in the nav menu
        if (e.shiftKey && !nav.contains(target)) {
            player.closeOutlineMenu();
            /*
            document.removeEventListener('click', player.nav_click_listener);
            document.removeEventListener('keyup', player.nav_keyup_listener);
            $('#nav_toc_button').attr('aria-expanded', 'false');
            */
            return true;
        }

        // close menu if target isn't in nav menu
        if (!nav.contains(target)) {
            player.closeOutlineMenu();
            /*
            document.removeEventListener('click', player.nav_click_listener);
            document.removeEventListener('keyup', player.nav_keyup_listener);
            $('#nav_toc_button').attr('aria-expanded', 'false');
            */
            return true;
        }
    },

    initialize: function () {

        AriaText.initLiveFeedback();

        this._super();

        this.activity = new Activity_subtype();

    },

    initialize2: function () {

        console.log('initialize2()');
      
        // if ARGA is running, note here whether or not *any* data has been saved for the user
        // that is, whether a submission has been initialized
        if (player.ARGA_running) {
            // we know something has been stored if "complete" is not an empty string
            if (Get_ARGA_Data("complete") != "") {
                this.ARGA_submission_initialized = true;
            }
        }

        // initialize activity (e.g. questions) and sections
        this.activity.initialize();
        this.initialize_sections();

        this.show_navigation();

        // if ARGA is running, do some things
        if (player.ARGA_running) {
            // show custom initialization alert
            // note that we do further initialization after that alert has been responded to;
            // see ARGA_initialization_final
            this.activity.ARGA_initialization_alert();
        }
        // otherwise just show section 0
        else {
            console.log('initialize2: calling routie for section 0');

            var url_hash = window.location.hash;

            console.log('url hash = ', url_hash);

            if (url_hash === '#digfir_section_0') {
                this.show_section(initial_section_index);
            }
            else {
                routie('#digfir_section_0');
            }
        }

        var idx = 1;
        $('[data-heading').each(function () {
            var $this = $(this);
            var heading = $this.attr('data-heading');
            $this.removeAttr('data-heading');
            if (heading === 'h2') {
                var headingHtml = $this.html();
                $this.html('<span class="visually-hidden">Slide ' + idx + ', </span>' + headingHtml);
                $this.attr('tabindex', '-1');
                idx++;
            }
            $this.changeElementType(heading);
        });

        $('[data-type="metadata"]').remove();

        //player.updateFinalReport();

    },

});

var player = new Player_subtype();


Query.prototype.setError = function (errMesg) {

    var alertIcon = '<svg version="1.0" xmlns="http://www.w3.org/2000/svg" width="1280.000000pt" height="1138.000000pt" viewBox = "0 0 1280.000000 1138.000000" preserveAspectRatio="xMidYMid meet" role="image" aria-hidden="true"><g transform="translate(0.000000,1138.000000) scale(0.100000,-0.100000)" stroke="none"><path d="M6280 11374 c-14 -2 -51 -9 -83 -15 -252 -45 -510 -210 -661 -422 -24 -34 -754 -1293 -1621 -2797 -868 -1504 -2077 -3601 -2688 -4660 -611 -1059 -1125 -1959 -1142 -2000 -119 -280 -110 -601 25 -876 140 -287 381 -485 698 -572 l97 -27 5495 0 5495 0 97 27 c317 87 558 285 698 572 136 277 145 590 25 876 -17 41 -531 941 -1142 2000 -611 1059 -1820 3156 -2688 4660 -867 1504 -1597 2763 -1621 2797 -189 266 -496 428 -829 438 -71 2 -141 2 -155 -1z m137 -1086 c6 -13 330 -576 720 -1253 390 -676 1321 -2290 2068 -3585 747 -1295 1621 -2809 1941 -3365 l583 -1010 -2665 -3 c-1465 -1 -3863 -1 -5328 0 l-2665 3 289 500 c1005 1744 2443 4238 3645 6322 765 1327 1393 2412 1396 2413 3 0 10 -10 16 -22z"/><path d="M6275 7456 c-338 -64 -584 -357 -585 -694 0 -45 27 -233 70 -490 257 -1521 290 -1713 300 -1750 23 -85 111 -185 198 -225 67 -31 217 -31 284 0 87 40 175 140 198 225 5 18 39 209 75 423 36 215 86 507 110 650 187 1098 188 1105 182 1205 -14 258 -166 484 -402 596 -134 64 -294 86 -430 60z"/><path d="M6313 3549 c-415 -48 -701 -459 -603 -868 62 -257 270 -466 525 -527 90 -21 240 -21 330 0 377 90 615 478 525 855 -84 351 -416 581 -777 540z"/></g></svg>';

    $('#question_error_div_' + this.parent_question.index).html(alertIcon + errMesg).css('display', 'block');
}

Query.prototype.clearError = function () {
    $('#question_error_div_' + this.parent_question.index).html('').css('display', 'none');
}


DD_Query = DD_Query.extend({

    getHTML: function (mode) {
        var html = "";

        // DD's never have query text
        // Start a nobr tag for the item
        html = '<span class="query_dd_select_span">';

        // if we're in preview mode or 
        // (a student answer has been given and we're not in review_correct_incorrect mode), 
        // or the student got it correct
        // disable the select
        var disabled = "";
        if (mode == 'preview' || (mode != 'review_correct_incorrect' && this.user_answer_index != null) || this.isCorrect()) {
            disabled = "disabled";
        }

        var initialOption = "Choose a chapter";

        html += '<select class="query_dd_select" id="query_answer_' + this.query_index + '" ' + disabled + '>'
            + '<option value="-1">' + initialOption + '</option>'

        for (var j = 0; j < this.choices.length; ++j) {
            var index = this.choice_order[j];
            var selected = "";
            // select the student answer, unless we're in preview mode
            if (this.user_answer_index == index && mode != 'preview') {
                selected = "selected"
            }
            html += '<option value="' + index + '" ' + selected + '>' + this.choices[index] + '</option>';
        }
        html += '</select>'
        html += this.finish_inline_query(this.choices[this.correct_answer_index], mode);

        // Close off the nobr tag for the item
        html += '</span>';

        return html;
    }

});

Essay_Query = Essay_Query.extend({

    // this is called by question.is_complete() to determine if question has been completed
    // since we can have a min word limit for essay questions, we can't just check if the user
    // has entered text, we must check that they entered enough text to get a grade of 100
    userHasAnswered: function () {
        //return (this.user_answer != "" && this.user_answer != null);
        return (this.grade == 100);
    },

    getUserAnswerForARGA: function () {
        if (this.user_answer == null || this.user_answer == "") {
            return "Not answered";
        }
        else {
            var sanitizedAnswer = sanitizeHtml(this.user_answer, {
                allowedTags: ['br'],
                allowedAttributes: {},
                disallowedTagsMode: 'recursiveEscape'
            });
            //return this.user_answer;
            return sanitizedAnswer;
        }
    },

    query_text_html: function () {

        //return "";

        var prefix = '';
        if (this.parent_question.md.question_number) {
            prefix = '<span class="visually-hidden">Question ' + this.parent_question.md.question_number + ': </span>';
        }

        if (this.query_text != "" && this.md._hide_query_text != "true") {
            // replace newlines with <br />
            var qt = jQuery.trim(this.query_text).replace(/\n/g, "<br>")

            return "<label class='query_text' for='query_answer_"+ this.query_index + "'>" + prefix + qt + "</label>"
        } else {
            return "";
        }
    },

    getHTML: function (mode) {
        // start with the query text, if there
        var html = this.query_text_html();

        var val, disabled;
        if (!this.userHasAnswered() || mode == 'preview') {
            val = "";
            disabled = "";

            // otherwise we have an answer, so fill it in
        } else {
            // make sure we convert double quotes to &#34; for placement in 'value="xxx"' attributes
            val = this.user_answer;

            // convert breaks to newlines
            val = val.replace(/<br *(\/)?>/g, "\n");

            // also disable the input if we're not in review_correct_incorrect mode
            if (mode != "review_correct_incorrect") {
                disabled = "aria-disabled='true' readonly tabindex='-1'";
            }
        }

        html += "<textarea id='query_answer_" + this.query_index + "' class='query_essay_ta' " + disabled + ">"
            + val + "</textarea>";

        // if answer was just entered and grade is 100, also show the "provisional" message
        // (unless for this question it isn't provisional)
        if (this.answer_was_just_entered && this.grade == 100 && this.md.points_are_provisional == "true") {
            html += "<div class='essay_question_evaulation_feedback'>Your answer has been provisionally accepted. You'll get full credit for now, but your instructor may update your grade later after evaluating it.</div>";
        }

        return html;
    },

});

var AriaText = {

    setLiveText: function (text) {
        var $liveTextDiv = $('#live-feedback');

        var currTime = Date.now();
        $liveTextDiv.attr('data-lasttime', currTime);
        $liveTextDiv.html('');
        $liveTextDiv.html(text);

        setTimeout(function () {
            var lastTime = $liveTextDiv.attr('data-lasttime');
            if (Number(lastTime) === currTime) {
                $liveTextDiv.html('');
            }
        }, 3000);

    },

    initLiveFeedback: function () {
        var live = 'assertive';
        var liveFeedbackDiv = $('<div id="live-feedback" class="visually-hidden" role="alert"></div>');
        $('body').append(liveFeedbackDiv);
    }

};

var Standard_Dialog = function () {
    var $manuscript = $('#manuscript');
    var $body = $('body');
    var $dialog, $content;
    var options = {};

    return {
        open: function (html, opt) {
            // Extend default options
            options = $.extend(true, (opt || {}), {
                width: 450,
                modal: true,
                draggable: false,
                resizable: false
            });

            // Set buttons
            if (options.buttons === 'none') {
                options.buttons = null;
            }
            else if (options.buttons === 'OK' || !options.buttons) {
                options.buttons = [{ text: 'OK', click: Standard_Dialog.close }];
            }

            // Remove previous dialog
            $('#standard_dialog_div').dialog('close').remove();

            if (options.modal) {
                $body.css('overflow', 'hidden');
            }

            // Hide other content from reader for mobile devices
            $manuscript.attr('aria-hidden', 'true');

            $dialog = $('<div id="standard_dialog_div"></div>');
            $content = $('<div class="dialog-div">' + (html || '') + '</div>');

            var activeEl = document.activeElement;
            var fneScrollTop = undefined;
            if (activeEl.classList.contains('question_submit_button')) {

                var activeElPos = activeEl.getBoundingClientRect();

                console.log('active element positioning: ', activeElPos);

                try {
                    var fne_content = window.parent.document.getElementById('fne-content');
                    var fneScrollTop = fne_content.scrollTop;

                    console.log('fneScrollTop: ' + fneScrollTop);
                }
                catch (e) {
                    console.log('caught error trying to get fne-content: ' + e.message);
                    fneScrollTop = undefined;
                }
            }

            $dialog.append($content);
            $dialog.dialog(options);

            if (fneScrollTop !== undefined) {
                var popUpTop;
                if (fneScrollTop < activeElPos.top) {
                    popUpTop = fneScrollTop + ((activeElPos.top - fneScrollTop) / 2)
                }
                else {
                    popUpTop = fneScrollTop;
                }
                $('.ui-dialog.ui-widget').css({ top: popUpTop + 'px' });
            }


            // If we open toc we use as description only instruction in the top of dialog and not links
            var isMenu = $content.find('#toc_head').length;
            var labelledBy = isMenu ? 'toc_head' : 'standard_dialog_div';

            var $parentDialog = $dialog.parent().attr({
                'tabindex': '0',
                'role': 'dialog',
                'aria-labelledby': 'ui-dialog-title-standard_dialog_div ' + labelledBy
            });

            $parentDialog.find('#ui-dialog-title-standard_dialog_div').attr({
                'role': 'heading',
                'aria-level': '1'
            });

            // Remove close btn
            $('.ui-dialog-titlebar-close').remove();

            var $lastBtn = $parentDialog.find('button').last();
            var $firstBtn = $parentDialog.find('button').first();

            // Attach events
            $parentDialog.bind('keydown', function (e) {
                var code = e.keyCode || e.which;

                if (code === KEY_CODES.ESC) {
                    if (typeof options.onEsc === 'function') {
                        options.onEsc();
                    }
                    else if (typeof options.buttons[0].click === 'function') {
                        options.buttons[0].click();
                    }
                    else {
                        Standard_Dialog.close(true);
                    }
                    //Standard_Dialog.close(true);
                }

                if (e.target === this && e.shiftKey && code === KEY_CODES.TAB) {
                    e.preventDefault();
                    $lastBtn.focus();
                }
            });
            $lastBtn.bind('keydown', function (e) {
                var code = e.keyCode || e.which;

                if (!e.shiftKey && code === KEY_CODES.TAB) {
                    $firstBtn.focus();
                    e.preventDefault();
                }
            });

            /*
            if (Platform.mobile) {
                // For android we set focus on dialog in any cases
                $parentDialog.focus();
            }
            else if (isMenu) {
                // If it is menu put focus on first link
                $parentDialog.find('a').first().focus();
            }
            else {
                // For other platform we set focus on first button
                if (options.buttons.length === 2) {
                    $lastBtn.focus();
                }
                else {
                    $firstBtn.focus();
                }
            }
            */
            
            $firstBtn.focus();
        },

        // for now alert is just like any other dialog; we could change that later.
        wait: function (html, opt) {
            options = opt || {};
            options.buttons = 'none';
            Standard_Dialog.open(html, options);
        },

        alert: function (html, opt) {
            Standard_Dialog.open(html, opt);
        },

        close: function () {
            // Show other content
            $manuscript.removeAttr('aria-hidden');

            if ($dialog) {
                $dialog.dialog('close').remove();
            }
            else {
                $("#standard_dialog_div").remove();
            }

            if (options.from) {
                options.from.focus();
            }

            if (options.modal) {
                $body.css('overflow', 'auto');
            }
        }
    };
}();

var KEY_CODES = {
    SPACE: 32,
    ENTER: 13,
    ESC: 27,
    TAB: 9
};