var SaviBcHandlers = SaviBcHandlers || {};

function viewingInPx() {
    if (typeof window.PX !== 'undefined') {
        return true;
    }
    if (typeof window.parent.PX !== 'undefined') {
        return true;
    }
    return false;
}

routie('digfir_section_?:sec', function (sec) {
    sec = Number(sec);

    console.log('routie: sec = ', sec);
    console.log('routie: player.sections.length = ', player.sections.length);

    if (isNaN(sec) || sec < 0) {
        console.log('routie: invalid section number');
        return;
    }

    if (sec === 0) {
        console.log('routie: user can always view section 0');
        player.show_section(0, true);
        return;
    }

    if (player.sections.length > 0 && sec > (player.sections.length - 1)) {
        console.log('routie: section number exceeds number of sections');
        return;
    }

    if (!player || typeof player.canViewSection !== 'function') {
        console.log('routie: player.canViewSection not found');
        return;
    }

    // We don't need to do anything if we are already on this section
    if (sec === player.section_currently_showing) {
        console.log('routie: already on section ' + sec);
        return;
    }

    if (player.canViewSection(sec)) {
        // If we are using routie then we want to focus on the h2
        console.log('routie: routing to section ' + sec);
        player.show_section(sec, true);
    }
    else {
        console.log('routie: user does not have permission to view section ', sec);
    }
});


$('[data-type="section"]').removeAttr('level');

$('[http-equiv="X-UA-Compatible"]').remove();

(function ($) {
  $.fn.changeElementType = function (newType) {
    var attrs = {};

    $.each(this[0].attributes, function (idx, attr) {
      attrs[attr.nodeName] = attr.nodeValue;
    });

    this.replaceWith(function () {
      return $("<" + newType + "/>", attrs).append($(this).contents());
    });
  };
})(jQuery);

$('br.clear').remove();


var media_literacy = /Media Literacy Activity/.test($('title').text());
var exploring_careers = /Exploring Careers/.test($('title').text());

if (!media_literacy && !exploring_careers) {
    $('h2.section-title').remove();
}

if (media_literacy || exploring_careers) {

    $('body').addClass('media-literacy');
    if (exploring_careers) {
        $('body').addClass('exploring-careers');
    }

    $('h2.section-title').removeClass('section-title').addClass('article-heading');

    $('[data-block_type="border-container"]').each(function () {
        var $this = $(this);
        var $inner_box = $this.find('[data-type="box_inner"]');
        var html = $inner_box.html();
        $this.replaceWith(html);
    });

    $('[data-element="dl"]').each(function () {
        var $this = $(this);
        var $inner_box = $this.find('[data-type="box_inner"]');
        var html = $inner_box.html();
        $this.html(html);
        $this.removeAttr('data-type');
    });

    $('[data-type="box"][data-element="dd"]').each(function () {
        var $this = $(this);
        var $inner_box = $this.find('[data-type="box_inner"]');
        var html = $inner_box.html();
        $this.html(html);
        $this.removeAttr('data-type');
        $this.changeElementType('dd');
    });

    $('[data-block_type="underlined-text"]').each(function () {
        var $this = $(this);
        var $p = $this.find('p');
        var text = $p.html();
        text = text.replace(/<(\/)?strong>/g, '');
        $this.html(text);
        $this.changeElementType('h3');
    });

    var h2ArticleCount = 0;
    $('h2.article-heading').each(function () {
        var $h2 = $(this);
        $h2.attr('id', 'sec' + h2ArticleCount + 'h2').attr('tabindex', '-1');
        h2ArticleCount++;
    });
}

$('[data-type="rawhtml"]').each(function () {
    var $this = $(this);
    var html = $this.html();
    $this.replaceWith(html);
});

$('#manuscript').changeElementType('main');

$('div[data-type="question"]').each(function () {
    $(this).changeElementType('form');
});

$('[data-type="query_display"]').remove();

$('[data-type="query"]').each(function () {
    $(this).changeElementType('div');
});

$('[data-block_type="abbr"]').each(function () {
    $(this).changeElementType('abbr');
});

$('[data-block_type="cite"]').each(function () {
    $(this).changeElementType('cite');
});

$('[data-element]').each(function () {
    var $this = $(this);
    var el = $this.attr('data-element');
    $this.removeAttr('data-element');
    $this.changeElementType(el);
});

$('[data-id]').each(function () {
    var $this = $(this);
    var id = $this.attr('data-id');
    $this.removeAttr('data-id');
    $this.attr('id', id);
});

$('[data-class]').each(function () {
    var $this = $(this);
    var classes = $this.attr('data-class');
    $this.removeAttr('data-class');
    $this.addClass(classes);
});

$('[data-label_for]').each(function () {
    var $this = $(this);
    var labelFor = $this.attr('data-label_for');
    this.setAttribute('for', labelFor);
    $this.removeAttr('data-label_for');
    $this.changeElementType('label');
});

$('[data-aria_labelledby]').each(function () {
    var $this = $(this);
    var id = $this.attr('data-aria_labelledby');
    $this.removeAttr('data-aria_labelledby');
    $this.attr('aria-labelledby', id);
});

$('[data-aria_label]').each(function () {
    var $this = $(this);
    var label = $this.attr('data-aria_label');
    $this.removeAttr('data-aria_label');
    $this.attr('aria-label', label);
});

$('[data-aria_hidden]').each(function () {
    var $this = $(this);
    var state = $this.attr('data-aria_hidden');
    $this.removeAttr('data-aria_hidden');
    $this.attr('aria-hidden', state);
});

$('h3[data-for_type="box"]').each(function () {
    var $this = $(this);
    if ($this.text() === '') {
        $this.remove();
    }
});

$('[data-type="box"]').each(function () {
    var $this = $(this);
    var $innerBox = $this.find('[data-type="box_inner"]');
    var html = $innerBox.html();
    $innerBox.remove();
    $this.html(html);
});

$('[data-type="figure_text"]').each(function () {
    var $this = $(this);
    var caption = $this.find('[data-type="caption"]').html();
    $this.html(caption);
    $this.removeAttr('data-type');
    $(this).changeElementType('figcaption'); 
});

$('[data-type="figure"]').each(function () {
    var $this = $(this);
    $this.removeAttr('data-type').removeAttr('data-layout-align').removeAttr('data-layout-width').removeAttr('data-layout-border').removeAttr('data-altsrc');
    var id = $this.attr('data-figure-id');
    if (id) {
        $this.attr('id', id);
    }
    $this.removeAttr('data-figure-id');
    var maxWidth = $this.attr('data-max_width');
    if (maxWidth) {
        $this.css('max-width', maxWidth + 'px');
    }

    var $img = $this.find('img');
    var img_src = $img.attr('src');
    /*
    $img.after('<div class="enlarge-img-link"><a href="' + img_src + '" target="_blank"><span class="visually-hidden">View full size image, opens in new window</span></a></div>');
    */
    $img.after('<div class="expand-figure-wrap"><a href="#' + id + '" class="expand-figure">Expand Figure <span class="visually-hidden">Opens in new window</span></a></div>');

    $this.changeElementType('figure'); 
});

$('[data-block_type="http"]').each(function () {
    var $url = $(this);
    var $parent = $url.parent();
    var urlText = $url.html();
    urlText = urlText.replace('https:', 'http:');
    $url.replaceWith(urlText);
});

var secCounter = 0;
$('[data-type="section"]').each(function () {
    $this = $(this);
    $this.attr('aria-labelledby', 'sec' + secCounter + 'h2');
    secCounter++;
    $this.changeElementType('article');
});

$('[data-type="question').each(function () {
    var $h3 = $(this).find('h3').first();
    $h3.remove();
});

$('#print_summary').each(function () {
    var $this = $(this);
    $this.html('Print Summary<span class="visually-hidden"> Opens in new window</span>');
    $this.changeElementType('button');
});

$('img').each(function () {
    $(this).removeAttr('id'); 
});

var Activity_subtype = Activity_manuscript_type = Activity.extend({

    ARGA_initialization_alert: function () {
        // This overrides the standard ARGA initialization message, which doesn't
        // tell the user he/she can resubmit (or tell him his grade)
        var grade = Get_ARGA_Grade();
        var due_date_passed = (Get_ARGA_Data("due_date_has_passed") == "1");
        var msg = "";
        var buttons;
        var modalTitle = "Please Note";

        due_date_passed = false;

        if (grade != "" && grade != null && grade >= 0) {
            // if resubmissions are allowed...
            if (player.md.allow_resubmission == "true") {
                // if due date has not passed, give the student the option of resubmitting or reviewing
                if (!due_date_passed) {
                    msg = "<p>You have completed this activity, and your grade (" + grade + "%) has been submitted. Would you like to:</p><ul>"
                        + "<li><b>Keep your current grade</b> and review your previous answers</li>"
                        + "<li>Or reset your submission and <b>try the activity again</b>?</li>"
                        + "</ul>"
                        ;
                    buttons = [{ text: "Keep current grade", click: player.activity.ARGA_initialization_final }
                        , { text: "Try Activity Again", click: function () { player.activity.ARGA_initialization_final("reset") } }
                    ];

                } else {
                    msg = "<p>You have completed this activity, and your grade (" + grade + "%) has been submitted. Since the due date for the activity has now passed, you cannot re-submit answers to the activity questions.</p>"
                    buttons = [{ text: "OK", click: player.activity.ARGA_initialization_final }];
                }

                // resubmissions are not allowed
            } else {
                msg = "You have completed this activity. Please check the gradebook for your final grade.";
                modalTitle = "Activity Completed"
                buttons = [{ text: "OK", onClick: player.activity.ARGA_initialization_final }];
            }

            // grade has not been submitted
        } else {
            // if due date has passed, tell the user "tough luck". Otherwise show nothing.
            if (due_date_passed) {
                msg = "The due date for this activity has passed.  You can still review the activity, but no answers will be submitted and no grade will be recorded.";
                modalTitle = "Due Date Has Passed"
                buttons = [{ text: "OK", onClick: player.activity.ARGA_initialization_final }];
            }
        }

        // if we need a message, show it in a jquery UI dialog
        //if (msg != "") {
        if (0) {
            ARIAmodal.openModal(
                {
                    modalId: 'aria_modal',
                    top: player.getModalTop(),
                    title: modalTitle,
                    text: msg,
                    buttons: buttons,
                    closeFocus: 'banner_activity_title'
                }
            );
        }
        else {
            player.activity.ARGA_initialization_final();
        }
    },

    add_question: function (index, element) {
        var a = player.activity;	// this fn gets called within the scope of a jquery each, so we can't refer to "this"

        var jq = $(element);

        // see if we're in a question_pool or question_sequence block
        var qs_parent = jq.parents("[data-block_type=question_sequence], [data-block_type=question_sequence_one_at_a_time]");

        var q = a.questions[a.questions.length] = new Question({
            "index": a.questions.length
            , "number": jQuery.trim($("[data-type='number']", jq).html())
            , "title": jQuery.trim($("[data-type='title']", jq).html())
            , "jq": jq
            , "points_possible": 0
        });

        // store the question index in the DOM too
        jq.attr("data-question_index", q.index);

        // get question queries		
        a.question_being_initialized = q;
        $("[data-type='query']", jq).each(a.add_query);

        // if the question has queries, add bling to the bottom
        if (q.queries.length > 0) {


            var html = "<div class='question_error_div' id='question_error_div_" + q.index + "'></div>";

            html += "<div class='question_action_div' id='question_action_div_" + q.index + "'>";

            var submit_handler;
            // add a submit button if we're supposed to have one
            // (image map and matching questions, which should contain one and only one query, don't have submit buttons)
            if (q.queries[0].hasSubmitButton === true) {
                // "answer_one" pool mode (yet to be fully implemented...)
                if (q.pool_mode == 'answer_one') {
                    html += "<input class='standard_button question_submit_button' type='button' id='question_submit_button_" + q.index + "' value='Answer This Query' />";
                    submit_handler = player.activity.Show_Submit;

                } else {
                    html += a.question_submit_button(q);
                    submit_handler = player.activity.submit_question;
                }
            }

            // add a "give up" button if we're supposed to have one
            // (image map questions, which should contain one and only one query, should have this button)
            if (q.queries[0].hasGiveUpButton === true) {
                html += "<input class='standard_button question_submit_button' type='button' id='question_submit_button_" + q.index + "' value='Give Up' />";
                submit_handler = player.activity.give_up_question;
            }

            html += "</div>";

            jq.append(html);

            // bind the submit_handler function to the button, passing in the question_index
            $("#question_submit_button_" + q.index).click({ question_index: q.index }, submit_handler);

            // float instructor controls to right of action button
            jq.prepend(a.instructor_question_controls(q));

            // also, determine question points and weight at this time
            for (var i = 0; i < q.queries.length; ++i) {
                q.points_possible += q.queries[i].getPointsPossible();
            }
            // round to two decimal places, in case there are decimals
            q.points_possible = Math.round(q.points_possible * 100) / 100;
        }

        // now that the question has been created, deal with sequences and pools
        if (qs_parent.length > 0) {
            // get sequence index and item
            var qs_index = qs_parent.attr("question_sequence_index") * 1;
            var qs = a.question_sequences[qs_index];

            // place in sequence
            var sequence_num = qs.questions.length;
            qs.questions[sequence_num] = q;

            // place reference to sequence in question
            q.question_sequence = qs;
            q.question_sequence_index = sequence_num;

            // if this isn't #1, hide the question
            if (sequence_num > 0) {
                jq.hide();
            }

            // update the sequence navigator if it's there
            $("#question_sequence_max_index_" + qs.index).html(sequence_num + 1);
        }

        // Adjust heading
        /*
        var metadata = player.activity.questions[q.index].md;
        var $heading = $('[data-question_index="' + q.index + '"]').find('h3');
        if (metadata.question_number) {
            $heading.text('Question ' + metadata.question_number);
        }
        else {
            $heading.text('Question');
        }

        if (metadata.heading_hidden === 'true') {
            $heading.addClass('visually-hidden');
        }

        if (metadata.heading_level) {
            $heading.changeElementType('h' + metadata.heading_level);
        }
        */

    },

    question_submit_button: function (q) {
        // define question_submit_button_label as a variable so it can be overridden

        console.log('question_submit_button: ', q);

        var hiddenText = q.md.submit_text || 'Question ' + q.index;

        var button_html = "<button class='standard_button question_submit_button' id='question_submit_button_"
            + q.index
            + "'>Submit <span class='visually-hidden'>"
            + hiddenText
            + "</span></button>";
        return button_html;
    },

    show_grade_saved_message: function () {
        // if the user has answered all queries AND the user hasn't been told
        // this already, tell them now
        if (player.activity.answered_all_queries && !player.user_has_received_completion_alert) {
            //setTimeout('Standard_Dialog.alert("You have completed the activity, and your grade has been submitted.");', 20);
            player.user_has_received_completion_alert = true;
        }
    },

    submit_question: function (question_index) {

        // The submit button handler is killing the click event and thus 
        // we need to manually close the outline menu if it is open because
        // the event is not reaching document.
        player.closeOutlineMenu();

        let event;

        if (typeof question_index == "object") {
            // question_index is actually the event object and we need 
            // save it off so we can stop propagation later on if
            // needed
            event = question_index;
            // extract the question_index from the object
            question_index = question_index.data.question_index;
        }

        var question = player.activity.questions[question_index];
        var query = question.queries[0];

        if (query.getQueryTypeForARGA() === 'drop-down') {
            var userAnswer = $('#query_answer_' + query.query_index).val();
            if (Number(userAnswer) < 0) {
                var errMesg = player.activity.questions[question_index].md.input_error || 'Error!';
                query.setError(errMesg);
                AriaText.setLiveText(errMesg);
                return false;
            }
            else {
                query.clearError(errMesg);
            }
        }
        else if (query.getQueryTypeForARGA() === 'essay') {
            var userAnswer = $('#query_answer_' + query.query_index).val().trim();
            if (userAnswer === "") {
                var errMesg = "You must enter an answer before submitting."
                query.setError(errMesg);
                AriaText.setLiveText(errMesg);
                return false;
            }
            else {
                query.clearError(errMesg);
            }
        }
        else if (question.md.multiple_mc === 'true') {
            var unanswered = [];
            for (var i = 0; i < 15; i++) {
                var query = question.queries[i];
                var checked = query.jq.find('input:checked');
                if (checked.length === 0) {
                    unanswered.push(i + 1);
                }
            }
            if (unanswered.length > 0) {
                var errMesg = "You must answer the following questions before submitting: " + unanswered.join(', ');
                query.setError(errMesg);
                AriaText.setLiveText(errMesg);
                return false;
            }
            else {
                query.clearError(errMesg);
            }
        }

        event.preventDefault();
        event.stopPropagation();

        if (query.getQueryTypeForARGA() === 'essay') {
            
            ARIAmodal.openModal(
                {
                    modalId: 'aria_modal',
                    top: player.getModalTop(),
                    title: 'Verify Submission',
                    text: 'Do you want to submit your answer? You will not be able to edit your answer after submitting.',
                    buttons: [
                        {
                            text: 'Cancel', onClick: function () {
                                player.setFocus('question_submit_button_' + question_index);
                            }
                        },
                        {
                            text: 'Submit', onClick: function () {
                                player.activity.submit_question_go(question_index);
                            }
                        }
                    ],
                    closeFocus: 'question_submit_button_' + question_index
                }
            );

            return;

        }
        else {
            player.activity.submit_question_go(question_index);
        }
    },

    submit_question_go: function (question_index) {

        // the arg may be a number or an event object; in the latter case...
        if (typeof question_index == "object") {
            // extract the question_index from the object
            question_index = question_index.data.question_index;
        }

        var t = player.activity;

        var question = t.questions[question_index];

        var all_answers_correct = true;
        // for each query in the question...
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];

            // evaluate the answer. If evaluateAnswer returns false, the answer isn't submittable at this time -- 
            // most likely because it's a free-response answer that needs to be evaluated via MAVE.
            var answer_submittable = query.evaluateAnswer(question_index);
            if (answer_submittable === false) {
                // as soon as we get an unsubmittable answer, we return. submit_question
                // will be called again, either by the callback fn of MAVE or because the student
                // resubmits. At that point we'll catch any additional free-response answers that need
                // checking, or we'll finish this loop here and move on.
                return;
            }
            all_answers_correct = all_answers_correct && query.isCorrect();
        }

        // if we made it to here, we're at least going to show which items are correct and incorrect
        // we might overwrite with review mode below, but that's OK
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];
            query.jq.html(query.getHTML("review_correct_incorrect"));
        }

        // update question tries
        ++question.tries;

        // if answer is incorrect, and max_tries is set, and # of tries is less than max_tries
        // (and the user didn't just give up)
        if ((!all_answers_correct && question.md.max_tries != null && question.tries < question.md.max_tries) && question.gave_up != true) {
            // tell user he can try again
            t.show_question_feedback(question, false, true);
            return;
        } else {
            t.show_question_feedback(question, all_answers_correct, false);
        }

        $('#question_feedback_' + question_index).focus();

        // if we make it to here we need to set ARGA info for the question, and show queries in review mode
        // if md.question_report_text is set, we submit the question as a whole, rather than as individual queries
        var query_correct_answers = "";
        var query_responses = "";
        var query_responses_for_questionData = "";
        var query_grade_sum = 0;
        // for each query in the question...
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];

            // establish a question number to use
            var query_number = t.get_query_number(question, i);

            // get a query weight
            var query_weight = question.get_weight();
            // if the question has more than one query, divide weight accordingly
            if (question.queries.length > 1) {
                query_weight = Math.round(query_weight / question.queries.length);
            }

            // if credit_after_max_tries is set, give at least that credit now, as long as the student tried
            if (question.md.credit_after_max_tries != null) {
                var query_grade = query.getGradeForARGA();
                if (query_grade >= 0 && query_grade < question.md.credit_after_max_tries) {
                    query.overrideGrade(question.md.credit_after_max_tries * 1);
                }
            }

            // set the ARGA response, unless we're saving one response for the whole question
            if (!question.md_set("question_report_text")) {
                t.ARGA_set_query_response(query, query_number, query_weight);

                // otherwise compose query roll-ups
            } else {
                if (query_correct_answers != "") {
                    query_correct_answers += " / ";
                    query_responses += " / ";
                    query_responses_for_questionData += t.query_responses_separator;
                }
                query_correct_answers += query.getCorrectAnswerForARGA();
                query_responses += query.getUserAnswerForARGA();
                // see restore_saved_answers for how this is used later
                query_responses_for_questionData += query.getUserAnswerForARGA()
                    + t.query_responses_grade_separator
                    + query.getOriginalGrade();
                query_grade_sum += query.getGradeForARGA() * 1;
            }

            // show in review mode, unless question metadata says not to show correct answers
            if (question.md.show_correct_answers != "false") {
                query.jq.html(query.getHTML("review"));
            }
        }

        // if we're saving one response for the whole question, save here
        if (question.md_set("question_report_text")) {
            var question_grade = Math.round(query_grade_sum / question.queries.length);
            t.ARGA_set_question_response(question, query_correct_answers, query_responses, question_grade, query_responses_for_questionData);
        }

        // grade the activity
        t.grade_activity();

        // then if ARGA is running, submit data; show_grade_saved_message will be called on completion.
        if (player.ARGA_running) {
            t.ARGA_submit_data();
        }

        // update the question_action_div
        t.update_question_action_div(question_index);

        // if the item is in a sequence, show the next question
        t.show_next_question(question);

        // update section status
        player.update_section_status();

        var s = player.get_current_section();

        // if all questions are answered and all sequences are complete
        // (these are set by _super)
        if (s.all_questions_answered && s.all_question_sequences_completed) {
            // if we're not on the final step
            if (s.index < player.sections.length - 1) {
                // then show the buttona
                //UI_Elements.toggle_button("step_button", true);
                $('#step_link').attr('aria-disabled', 'false');

                // otherwise we're done!
            }
            else {
                player.show_completion_message();
            }
        }

        player.update_navigation();

        //player.updateFinalReport();

        // focus on question feedback
        /*
        setTimeout(function () {
            $('#question_feedback_' + question_index).focus();
        }, 250);
        */
    },

    update_question_action_div: function (question_index) {
        var question = this.questions[question_index];

        // calculate points_awarded and points_possible
        var points_awarded = 0;
        var points_possible = 0;
        var points_provisional = false;
        for (var i = 0; i < question.queries.length; ++i) {
            var query = question.queries[i];
            points_awarded += query.getPointsAwarded();
            points_possible += query.getPointsPossible();
            if (query.pointsAreProvisional() == true) {
                points_provisional = true;
            }
        }

        // round to at most two decimal places
        points_awarded = Math.round(points_awarded * 100) / 100;
        points_possible = Math.round(points_possible * 100) / 100;

        // hide submit button (and any other similar buttons that might be added by subtypes), but show points earned
        var jq = $("#question_action_div_" + question.index);
        //jq.find(".question_submit_button").hide();
        jq.find(".question_submit_button").remove();
        var points_html = "<div class='points_awarded_div'>Points awarded: " + points_awarded + " out of " + points_possible;

        if (points_provisional) {
            points_html += " (<a href='javascript:player.activity.explain_provisional()'>provisional</a>)";
        }
        points_html += "</div>";

        var jq = $("#question_action_div_" + question.index);
        jq.find(".points_awarded_div").remove();
        if (jq.find(".question_feedback").length > 0) {
            jq.find(".question_feedback").after(points_html);
        } else {
            jq.prepend(points_html);
        }
    },

    show_question_feedback: function (question, is_correct, try_again) {
        // remove prior feedback if there
        $("#question_feedback_" + question.index).remove();

        // if we don't have any feedback at all, return
        if (question.md.feedback == null && question.md.feedback_correct == null && question.md.feedback_incorrect == null && question.md.feedback_hint == null) {
            return;
        }

        var fbHeadingLevel = question.md.feedback_heading ? Number(question.md.feedback_heading) : 4;

        var html = "<div class='question_feedback' id='question_feedback_" + question.index + "' tabindex='-1'>"
            + "<h" + fbHeadingLevel + " class='question_feedback_head'>" + this.feedbackTitle + "</h" + fbHeadingLevel + ">";

        var sr_fb = question.md.feedback_sr ? " <span class='visually-hidden'>" + question.md.feedback_sr + "</span>" : "";
        
        // include general feedback if there
        if (question.md.feedback != null) {
            html += "<div class='question_feedback_part'>" + question.md.feedback + sr_fb + "</div>";
        }

        // include correct feedback if there and the answer is correct
        if (is_correct && question.md.feedback_correct != null) {
            html += "<div class='question_feedback_part'>" + question.md.feedback_correct + "</div>";
        }

        // include incorrect or hint feedback if there and the answer is incorrect
        if (!is_correct) {
            var found_feedback_string = false;
            // if user gets to try again...
            if (try_again) {
                // check for feedback_conditional's
                if (question.md.feedback_conditional.length > 0) {
                    for (var i in question.md.feedback_conditional) {
                        var fbc = question.check_conditional(question.md.feedback_conditional[i]);
                        if (fbc != "") {
                            html += "<div class='question_feedback_part'>" + fbc + "</div>";
                            found_feedback_string = true;
                            break;
                        }
                    }
                }

                // if we didn't find a feedback string to use above, check for feedback_hint
                if (!found_feedback_string && question.md.feedback_hint != null) {
                    html += "<div class='question_feedback_part'>" + question.md.feedback_hint + "</div>";
                    found_feedback_string = true;
                }
            }

            // if we didn't find a feedback string to use above, check for feedback_incorrect
            if (!found_feedback_string && question.md.feedback_incorrect != null) {
                html += "<div class='question_feedback_part'>" + question.md.feedback_incorrect + "</div>";
            }
        }

        // close question_feedback div
        html += "</div>";

        // append the div, then fade it in
        $("#question_action_div_" + question.index).prepend(html);
        $("#question_feedback_" + question.index).show();
        /*
        $("#question_feedback_" + question.index).fadeIn("fast", function () {
            // What I'd like to do here is check to make sure the feedback is all showing on the screen,
            // and scroll if necessary so that the feedback is all visible. But just doing "scrollTo"
            // isn't working properly in all situations.
            // $(window).scrollTo($(this), 0);
        });
        */
    },

});


var Player_subtype = Player_manuscript_type.extend({

    FIRST_SHOW_SECTION: true,

    ACTIVITY_COMPLETED: false,
    DUE_DATE_HAS_PASSED: false,

    getQuestionAnswer: function (question_number) {
        var question = player.activity.questions[question_number];
        if (!question.is_complete()) {
            return "<p>Question not answered.</p>";
        }

        // if we have more than one query then this is a list of CB's
        if (question.queries.length > 1) {
            var html = "<div data-block_type='fieldset'>";
            var answers = "";

            // go through each query (CB) and if checked add it to answers
            for (var i = 0; i < question.queries.length; i++) {
                var answer = question.queries[i].getHTML('review');
                if (!/Not Checked/.test(answer)) {
                    answer = answer.replace(/<span type="checkbox" .*/, "");
                    answers += "<li>" + answer + "</li>";
                }
            }

            if (answers === "") {
                answers = "<p>No ACES scores were checked for this question.</p>";
            }
            else {
                answers = "<ul>" + answers + "</ul>";
            }

            html += answers + "</div>";
            return html;
        }
        // otherwise this is an MC or Essay question and we just have one query
        else {
            var answer = question.queries[0].getHTML('review');
            answer = answer.replace(/visually-hidden/, "");
            console.log(answer);
            var html = answer;
            /*
            if (question.queries[0].getQueryTypeForARGA() === "essay") {
                html = "<h3>Question</h3>" + html;
            }
            */
            return html;
        }
    },

    printSummary: function () {
        var win = window.open('asset/summary.html', 'printwindow');
    },

    canViewSection: function (num) {
        // section we want to move to
        var secNum = Number(num);

        if (isNaN(secNum) || secNum < 0 || (secNum > player.sections.length - 1)) {
            return false;
        }
        if (player.isInstructor()) {
            return true;
        }
        // We can always move to a section that is less than/equal to our
        // last available section
        if (typeof player.last_available_section === 'number') {
            if (secNum <= player.last_available_section) {
                return true;
            }
            else {
                console.log('canViewSection: requested section ' + secNum + ' is greater than last available section ' + player.last_available_section);
                return false;
            }
        }
        // We can always move backwards 
        if (typeof player.section_currently_showing === 'number') {
            if (secNum <= player.section_currently_showing) {
                return true;
            }
        }

        console.log('canViewSection: can\'t verify permissions');
        return false;
    },

    isInstructor: function () {

        if (player.ARGA_running && Get_ARGA_Data('user_rights') === '3_instructor') {
            return true;
        }
        else if (!player.ARGA_running) {
            try {
                const params = new URLSearchParams(window.location.search);
                if (params.has('instructor') && params.get('instructor') === 'true') {
                    return true;
                }
            }
            catch (e) { }
        }
        return false;
    },

    getQuestionAnswer: function (question_number) {
        var question = player.activity.questions[question_number];
        if (!question.is_complete()) {
            if (question.queries.length === 1) {
                return "<p>Question not answered.</p>";
            }
            else {
                return '';
            }
        }

        // essay question
        if (question.queries.length === 1) {
            return "<p>" + question.queries[0].getUserAnswerForARGA(); + "</p>";
        }
        // mc questionnaire
        var html = '';
        for (var i = 0; i < question.queries.length; i++) {
            html += `<p>` + (i+1) + '. ' + question.queries[i].query_text + ' ';
            html += `<b>` + question.queries[i].getUserAnswerForARGA().replace(/^(A|B)\. /, '') + '</b>';
        }
        return html;
    },

    updateFinalReport: function () {
        var $pspDiv = $('#your_psp');
        var headingBegin = "<h4>";
        var headingEnd = "</h4>";
        var userAnswer;
        var questions = player.activity.questions;

        var html = "<h3>Your Personal Success Plan</h3>";

        html += headingBegin + "Chapter" + headingEnd;
        userAnswer = questions[1].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Identify a Goal" + headingEnd;
        userAnswer = questions[2].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Make Your Goal SMART" + headingEnd;
        userAnswer = questions[3].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Create an Action Plan" + headingEnd;
        userAnswer = questions[4].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "List Barriers and Solutions" + headingEnd;
        userAnswer = questions[5].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        html += headingBegin + "Connect to Career" + headingEnd;
        userAnswer = questions[6].queries[0].getUserAnswerForARGA();
        html += "<p>" + userAnswer + "</p>";

        $pspDiv.html(html);
    },

    setFocus: function (arg) {
        if (typeof arg === 'string') {
            arg = document.getElementById(arg);
        }
        setTimeout(function () {
            try {
                arg.focus();
            }
            catch (err) {
                console.log('setFocus: ' + err.message);
            }
        }, 250);
    },

    getModalTop: function () {
        var fneContent = window.parent.document.getElementById('fne-content');
        if (fneContent === null || fneContent === undefined) {
            return undefined;
        }
        var fneHeight = fneContent.clientHeight;
        var scrollTop = fneContent.scrollTop;
        return scrollTop + (fneHeight / 2);
    },

    show_navigation: function () {
        
        // add <header> before <main>
        var header = "<header id='top_banner'>";

        /*
        if (this.activity_thumbnail_src != null) {
            header += "<img id='banner_thumbnail' src='" + this.activity_thumbnail_src + "' />";
        }
        */

        header += /*"<div id='banner_activity_type'>" + this.md.activity_type_title + "</div>"
            +*/ "<h1 id='banner_activity_title' tabindex='-1'>" + this.activity_title.replace(/Identifying/, 'Identi&#173;fying') + "</h1>"
            + "</header>"	// top_banner
            ;

        $('main').before(header);
        $('h1.section-title').remove();
        
        var nav = "";

        if (this.sections.length > 1 && this.md.hide_toolbar != "true") {
            
            $('main').before(this.create_nav_menu());

            $('#nav_toc_button').click(function (e) {
                e.preventDefault();
                e.stopPropagation();

                var $button = $(this);
                var expanded = $button.attr('aria-expanded') === 'true';
                if (expanded) {
                    player.closeOutlineMenu();
                }
                // This is the only place we add these event listeners
                else {
                    document.addEventListener('click', player.nav_click_listener);
                    document.addEventListener('keyup', player.nav_keyup_listener);
                    $button.attr('aria-expanded', 'true');
                }
                return false;
            });

            $('#nav_toc_submenu').click(function (e) {
                console.log('nav_toc_submenu.click')

                e.preventDefault();
                e.stopPropagation();

                if (e.target.tagName.toUpperCase() !== "A") {
                    return false;
                }

                var targetSec = Number($(e.target).attr('href').replace(/#digfir_section_/, ''));
                // we can always go backwards
                if (targetSec < player.section_currently_showing) {
                    $('#nav_toc_button').attr('aria-expanded', 'false');
                    player.show_section(targetSec, true);
                }
                // can we go forward?
                else if (targetSec > player.section_currently_showing) {
                    if (player.last_available_section >= targetSec || player.isInstructor()) {
                        $('#nav_toc_button').attr('aria-expanded', 'false');
                        player.show_section(targetSec, true);
                    }
                }
                return false;
            });
            
        }


        $('#manuscript').after('<nav id="slide_nav" aria-label="Slide"><a role="link" id="nav_prev_link" aria-disabled="true" aria-label="Previous slide"><span id="nav_prev_link_icon"><svg aria-hidden="true" focusable="false" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><g data-name="Layer 2"><g data-name="arrow-circle-left"><rect width="24" height="24" transform="rotate(90 12 12)" opacity="0"></rect><path d="M22 12a10 10 0 1 0-10 10 10 10 0 0 0 10-10zm-11.86 3.69l-2.86-3a.49.49 0 0 1-.1-.15.54.54 0 0 1-.1-.16.94.94 0 0 1 0-.76 1 1 0 0 1 .21-.33l3-3a1 1 0 0 1 1.42 1.42L10.41 11H16a1 1 0 0 1 0 2h-5.66l1.25 1.31a1 1 0 0 1-1.45 1.38z"></path></g></g></svg></span>Prev</a>' +
            
            '<div id="slide_number" aria-hidden="true"><span id="curr_slide"></span></div>' +
            
            '<a href="#digfir_section_1" id="nav_next_link" aria-disabled="false" aria-label="Next slide">Next<span id="nav_next_link_icon"><svg aria-hidden="true" focusable="false" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><g data-name="Layer 2"><g data-name="arrow-circle-right"><rect width="24" height="24" transform="rotate(-90 12 12)" opacity="0"></rect><path d="M2 12A10 10 0 1 0 12 2 10 10 0 0 0 2 12zm11.86-3.69l2.86 3a.49.49 0 0 1 .1.15.54.54 0 0 1 .1.16.94.94 0 0 1 0 .76 1 1 0 0 1-.21.33l-3 3a1 1 0 0 1-1.42-1.42l1.3-1.29H8a1 1 0 0 1 0-2h5.66l-1.25-1.31a1 1 0 0 1 1.45-1.38z"></path></g></g></svg></span></a>');

        
        $('#nav_prev_link').click(function (e) {
            var $link = $(this);
            var href = $link.attr('href');

            console.log('nav_prev_link click: ', $link, href);
            
            if (!(/#digfir_section_\d+/.test(href))) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }

            console.log('nav_prev_link click: returning true');
            return true;
        });

        $('#nav_next_link').click(function (e) {
            var $link = $(this);
            var href = $link.attr('href');

            console.log('nav_next_link click: ', $link, href);

            if (!(/#digfir_section_\d+/.test(href))) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }

            console.log('nav_next_link click: returning true');
            return true;
        });
        

    },

    create_nav_menu: function () {
        
        var nav = '<nav id="toolbar" aria-labelledby="nav_toc_button"><div id="controls">';

        nav += '<button id="nav_toc_button" aria-expanded="false" aria-controls="nav_toc_submenu"><svg focusable="false" aria-hidden="true" viewBox="0 0 18 18" xmlns="http://www.w3.org/2000/svg"><path d="M17 5H1a1 1 0 0 1 0-2h16a1 1 0 0 1 0 2zm0 5H1a1 1 0 0 1 0-2h16a1 1 0 0 1 0 2zm0 5H1a1 1 0 0 1 0-2h16a1 1 0 0 1 0 2z"/></svg><span>Outline</span></button><ul id="nav_toc_submenu">';

        for (var i = 0; i < player.sections.length; i++) {
            var $sec = $('#digfir_section_' + i);
            var $heading = $sec.find('.article-heading');
            var headingText = $heading.text();
            headingText = headingText.replace(/^(Questionnaire \d):.*/, "$1");
            nav += '<li><a href="#digfir_section_' + i + '"><span class="visually-hidden">Slide ' + (i + 1) + ', </span>' + headingText + '</a></li>';
        }

        nav += '</ul></div></nav>';

        return nav;
    },

    show_section: function (section_to_show, focus_h2) {

        $('.highlight').each(function () {
            $(this).removeClass('highlight'); 
        });

        $('.highlight2').each(function () {
            $(this).removeClass('highlight2');
        });

        var direction = "right";
        if (section_to_show == "previous") {
            section_to_show = this.section_currently_showing - 1;
            direction = "left";
        } else if (section_to_show == "next") {
            section_to_show = this.section_currently_showing + 1;
        }

        if (section_to_show == null || isNaN(section_to_show) || section_to_show < 0 || section_to_show >= this.sections.length) {
            return;
        }

        // if user has to view sections in sequence and hasn't gotten up to this one, don't allow it
        // brb: We are making this check elsewhere and don't need to show
        // these pop-up messages any more.
        if (this.md.sequenced_sections == "true" && section_to_show > this.last_available_section) {
            // but let instructors through
            if (player.activity.is_instructor()) {
                /*
                Standard_Dialog.alert("Please note: Students need to read and complete each section of the activity before moving on to the next section.  Instructors, however, can skip around between sections as they choose.");
                */
            } else {
                //Standard_Dialog.alert(this.md.section_sequence_message);
                return;
            }
        }

        // pause running video
        //player.savi_bc_videos.pauseAllVideos();

        player.savi_bc_videos.pauseAllVideos();

        this.show_section_animate(section_to_show, direction);

        // process iframes for the section, unless all were preloaded
        if (player.md.preload_all_iframes != "true") {
            this.figures.process_iframes(this.get_current_section().jq);		// iframes
        }

        this.update_section_status();

        $('#step_link').attr('href', '#digfir_section_' + (Number(player.section_currently_showing) + 1));

        // brb: set a small delay here so that screen reader does not
        // announce "unavailable" on Prev/Next links
        setTimeout(function () {
            player.update_navigation();
            if (!player.FIRST_SHOW_SECTION) {
                try {
                    parent.PX.API.Content.ResetHeight();

                }
                catch (e) { }
                finally {
                    if (focus_h2) {
                        $('#sec' + player.section_currently_showing + 'h2').focus();
                    }
                }
            }
            else {
                if (player.DUE_DATE_HAS_PASSED) {
                    if (!player.ACTIVITY_COMPLETED) {
                        $('#expired-mesg').removeAttr('hidden');
                    }
                    else {
                        $('#expired-mesg').remove();
                    }
                }
                else {
                    $('#expired-mesg').remove(); 
                }
                if (player.ACTIVITY_COMPLETED) {
                    $('#completed-mesg').removeAttr('hidden');
                }
                else {
                    $('#completed-mesg').remove();
                }
            }
            player.FIRST_SHOW_SECTION = false;
        }, 100);

    },


    show_section_animate: function (section_to_show, direction) {
        // make sure modal window is closed
        $("#toc_dialog").dialog("close");

        // slide in using parent function
        //this._super(section_to_show, direction);

        // hide currently showing section
        /*
        if (this.section_currently_showing != null) {
            this.get_current_section_jq().hide();
        }
        */
        $('.show-section').each(function () {
            $(this).removeClass('show-section');
        });
        
        this.section_currently_showing = section_to_show;

        this.get_current_section_jq().addClass('show-section');

        // update slide_number and title
        $("#slide_title").html(this.get_current_section().title);
        UI_Elements.update_button_label("slide_number", (section_to_show + 1) + " of " + this.sections.length + " ");

        // if this is the first/last section, dim the previous/next button
        if (this.section_currently_showing == 0) {
            $("#previous_button").addClass("button_dimmed");
        } else {
            $("#previous_button").removeClass("button_dimmed");
        }

        if (this.section_currently_showing == (this.sections.length - 1)) {
            $("#next_button").addClass("button_dimmed");
        } else {
            $("#next_button").removeClass("button_dimmed");
        }

        // scroll to top
        window.scrollTo(0, 0);
    },


    /* brb: Overriding this method in order to keep the activity from 
       updating ARGA if the activity has been completed or hasn't and is passed due date
       so that it doesn't overwrite a manual grade change in the grade book (see JIRA LP-127) */
    update_section_status: function () {
        if (this.section_currently_showing != null && this.last_available_section <= this.section_currently_showing) {
            var s = this.get_current_section();
            s.all_questions_answered = true;

            // if the current section has any questions, see if they've all been answered
            var qs_to_check = [];
            s.jq.find("[data-type=question]").each(function (index, element) {
                var q_index = $(element).attr("data-question_index");
                var question = player.activity.questions[q_index];
                s.all_questions_answered = s.all_questions_answered && question.is_complete();
                if (question.question_sequence != null) {
                    for (var i = 0; i < qs_to_check.length; ++i) {
                        if (qs_to_check[i] == question.question_sequence) break;
                    }
                    if (i == qs_to_check.length) {
                        qs_to_check.push(question.question_sequence);
                    }
                }
            });

            // now check question sequences to make sure they're done too
            s.all_question_sequences_completed = true;
            for (var i = 0; i < qs_to_check.length; ++i) {
                s.all_question_sequences_completed = s.all_question_sequences_completed && (qs_to_check[i].sequence_complete == "complete");
            }

            if (s.all_questions_answered && s.all_question_sequences_completed) {
                this.last_available_section = this.section_currently_showing + 1;
            }
        }

        this.fill_in_previous_query_responses();

        // if ARGA is initialized and we need to restore the user to his last position when he returns,
        if (this.ARGA_running && player.md.restore_last_viewed_section == "true") {
            // if we're viewing a page other than the one currently saved as LVS (last-viewed section)
            var lvs = Get_ARGA_Data("LVSX");
            if (this.section_currently_showing != null && this.section_currently_showing != lvs) {
                // store LVS/LAS to register the last-viewed/last-available page,
                // and save ARGA so it gets registered
                Set_ARGA_Data("LVSX", this.section_currently_showing);
                Set_ARGA_Data("LASX", this.last_available_section);

                /* brb: If the activity has not been completed then save LVSX, but if
                  it has been completed then do not save LVSX because that will also
                  send the grade to the PX grade book again, overwriting any manual
                  grade changes the instructor may have made. */
                /* brb: also don't want to do this if the due date has passed */
                if (!this.ACTIVITY_COMPLETED && !this.DUE_DATE_HAS_PASSED) {
                    this.activity.ARGA_submit_data(false);
                }
            }
        }
    },


    update_navigation: function () {

        // show/hide the bottom "next" button as appropriate
        if (this.last_available_section > this.section_currently_showing && this.showing_last_section() === false) {
            $('#step_link').attr('aria-disabled', 'false');
        }
        else if (player.isInstructor()) {
            $('#step_link').attr('aria-disabled', 'false');
        }
        else {
            $('#step_link').attr('aria-disabled', 'true');
        }

        if (this.showing_last_section() && player.activity.answered_all_queries) {
            player.show_completion_message();
        }


        // main nav

        // prev link
        if (this.section_currently_showing === 0) {
            $('#nav_prev_link').attr('role', 'link').attr('aria-disabled', 'true').removeAttr('href');
        }
        else {
            $('#nav_prev_link').attr('aria-disabled', 'false').attr('href', '#digfir_section_' + (this.section_currently_showing - 1)).removeAttr('role');
        }

        // next link
        if (this.section_currently_showing < (player.sections.length - 1)) {
            $('#nav_next_link').attr('aria-disabled', 'false').attr('href', '#digfir_section_' + (this.section_currently_showing + 1)).removeAttr('role');
            if (!player.canViewSection(this.section_currently_showing + 1)) {
                $('#nav_next_link').attr('aria-disabled', 'true').attr('role', 'link').removeAttr('href');
            }
        }
        else {
            $('#nav_next_link').attr('aria-disabled', 'true').attr('role', 'link').removeAttr('href');
        }

        // toc
        player.closeOutlineMenu();

        var secId = 0;
        $('#nav_toc_submenu').find('a').each(function () {
            var $link = $(this);
            var sec = -1;

            if (player.last_available_section >= secId || player.isInstructor()) {
                $link.attr('aria-disabled', 'false').removeAttr('role').attr('href', '#digfir_section_' + secId);
                sec = $link.attr('href').replace(/[^\d]+/, "");
            }
            else {
                $link.attr('aria-disabled', 'true').attr('role','link').removeAttr('href');
            }

            if (player.section_currently_showing === Number(sec)) {
                $link.attr('aria-current', 'page');
            }
            else {
                $link.removeAttr('aria-current');
            }
            secId++;
        });

    },

    /* Listens for clicks on the page outside of the toc menu and 
        closes the menu. This handler should be attached to document. */
    nav_click_listener: function (e) {
        console.log('nav_click_listener(): ', e.target);

        /* The nav menu has its own listener which will catch any clicks on 
           it and stop the event from propagating. So the only clicks this
           should catch are any outside of the menu and thus we should just
           close the menu. */

        player.closeOutlineMenu();
    },

    closeOutlineMenu: function () {
        // This doesn't seem to cause a problem if executed when these 
        // handlers aren't actually listening on document.
        document.removeEventListener('click', player.nav_click_listener);
        document.removeEventListener('keyup', player.nav_keyup_listener);
        $('#nav_toc_button').attr('aria-expanded', 'false');
    },

    nav_keyup_listener: function (e) {
        var nav = document.getElementById('controls');
        var target = e.target;
        
        // Handle Esc if target is in the nav menu (close menu)
        if (e.key.toUpperCase() === "ESCAPE" && nav.contains(target)) {
            e.preventDefault();
            player.closeOutlineMenu();
            $('#nav_toc_button').focus();
            return false;
        }

        // If this isn't the Tab key then we don't care
        if (e.key.toUpperCase() !== "TAB") {
            return;
        }
        
        // If Shift/Tab then close menu if target isn't in the nav menu
        if (e.shiftKey && !nav.contains(target)) {
            player.closeOutlineMenu();
            return true;
        }

        // close menu if target isn't in nav menu
        if (!nav.contains(target)) {
            player.closeOutlineMenu();
            return true;
        }
    },

    initialize: function () {

        AriaText.initLiveFeedback();

        this._super();
        
        $("h2").show();

        this.activity = new Activity_subtype();

    },

    initialize_sections: function() {

        this._super();

        // we need to do this here because the ids on the sections are not set
        // until super() is called

        this.savi_bc_videos = new SaviBcVideoCollection();
    },

    initialize2: function () {

        console.log('initialize2()');
      
        if (player.md.color_scheme) {
            $('body').addClass(player.md.color_scheme);
        }

        // if ARGA is running, note here whether or not *any* data has been saved for the user
        // that is, whether a submission has been initialized
        if (player.ARGA_running) {
            // we know something has been stored if "complete" is not an empty string
            if (Get_ARGA_Data("complete") != "") {
                this.ARGA_submission_initialized = true;
            }
        }

        // initialize activity (e.g. questions) and sections
        this.activity.initialize();
        this.initialize_sections();

        this.show_navigation();

        if (exploring_careers) {

            $('dl').find('a[target="_blank"]').each(function() {
                var $link = $(this);
                var html = $link.html();
                $this.html(html + '<span class="visually-hidden"> Opens in new window</span>');
            });

            (function () {
                var video_head = document.getElementsByTagName('head')[0];
                var video_style = document.createElement('link');
                video_style.href = 'asset/css/savi_video_local.css';
                video_style.type = 'text/css';
                video_style.rel = 'stylesheet';
                video_head.append(video_style);
            })();

            $.getScript("https://savi-cdn.macmillantech.com/brightcove/savi-brightcove-player.js", function (data, textStatus, jqxhr) { });
        }

        // if ARGA is running, do some things
        if (player.ARGA_running) {
            // show custom initialization alert
            // note that we do further initialization after that alert has been responded to;
            // see ARGA_initialization_final
            this.activity.ARGA_initialization_alert();
        }
        // otherwise just show section 0
        else {
            console.log('initialize2: calling routie for section 0');

            var url_hash = window.location.hash;

            console.log('url hash = ', url_hash);

            if (url_hash === '#digfir_section_0') {
                this.show_section(initial_section_index);
            }
            else {
                routie('#digfir_section_0');
            }
        }

        if (player.ARGA_running) {
            // brb: determine if activity has been completed (all ARGA answered)
            try {
                var dejs_arr = ARGA_API.dejs_data;
                for (var i = 0; i < dejs_arr.length; i++) {
                    if (dejs_arr[i].name === "cmi.completion_status") {
                        this.ACTIVITY_COMPLETED = (ARGA_API.dejs_data[i].value == "completed");
                        break;
                    }
                }
            }
            catch (err) {
                safe_log("initialize2: Can't get cmi.completion_status: " + err)
            }

            // brb: determine if due date has passed for assignment
            if (player.ARGA_running) {
                if (Get_ARGA_Data("due_date_has_passed") == 1) {
                    this.DUE_DATE_HAS_PASSED = true;
                }
            }
        }
        else {
            try {
                const params = new URLSearchParams(window.location.search);
                if (params.has('pastdue') && params.get('pastdue') === 'true') {
                    this.DUE_DATE_HAS_PASSED = true;
                }
            }
            catch (e) { }
        }

        // add custom SAVI CSS overrides to make responsive
        /*
        (function () {
            var video_head = document.getElementsByTagName('head')[0];
            var video_style = document.createElement('link');
            video_style.href = 'asset/savi_video_local.css';
            video_style.type = 'text/css';
            video_style.rel = 'stylesheet';
            video_head.append(video_style);
        })();
        */

        // load savi brightcove library
        // we have to load this here because there is an issue in Variables.init
        // in which the entire html in the manuscript div is replaced and we have
        // to wait for that to happen before activiating the savi-brightcove library
        /*
        $.getScript("https://savi-cdn.macmillantech.com/brightcove/savi-brightcove-player.js", function (data, textStatus, jqxhr) {

        });
        */

        // This needs to be done before processing footnotes
        $('[data-block_type="url"]').each(function () {
            var $url = $(this);
            var urlText = $url.text();
            urlText = formatUrl(urlText).replace(/<wbr><wbr>/g, "<wbr>");
            console.log(urlText);
            $url.replaceWith(urlText);
        });

        this.setupFootnotes();

        var idx = 1;
        $('[data-heading').each(function () {
            var $this = $(this);
            var heading = $this.attr('data-heading');
            $this.removeAttr('data-heading');
            if (heading === 'h2' && $this.hasClass('article-heading')) {
                var headingHtml = $this.html();
                $this.html('<span class="visually-hidden">Slide ' + idx + ', </span>' + headingHtml);
                $this.attr('tabindex', '-1');
                idx++;
            }
            $this.changeElementType(heading);
        });

        $('[data-type="metadata"]').remove();

        $('#print_summary').click(function () {
            player.printSummary(); 
        });

        $('button').each(function () {
            $(this).removeAttr('role'); 
        });

        if (this.DUE_DATE_HAS_PASSED && !this.ACTIVITY_COMPLETED) {

            $('button.question_submit_button').each(function () {
                var $this = $(this);
                $this.remove();
            });

            // disable all questions
            $('[data-type="question"]').each(function () {
                var $this = $(this);
                $this.find('textarea').attr("aria-disabled", true).attr('readonly', true).attr('tabindex', '-1');
            });

            $('#close_expired').click(function () {
                // go to new focus element
                $('#banner_activity_title').focus();
                // remove notice from DOM
                $('#expired-mesg').remove();
            });

            $('#completed-mesg').remove();
            return;
        }

        if (!this.ACTIVITY_COMPLETED) {
            $('#completed-mesg').remove();
        }
        else {
            $('#close_completed').click(function () {
                // go to new focus element
                $('#banner_activity_title').focus();
                // remove notice from DOM
                $('#completed-mesg').remove();
            });
        }

    },

    setupFootnotes: function () {

        $('[data-fnref]').each(function () {
            var $ref = $(this);
            var refNum = $ref.attr('data-fnref');
            var text = $ref.text();
            $ref.attr('id', 'fnref' + refNum);
            $ref.attr('href', '#footnote' + refNum);
            $ref.html('<span class="visually-hidden">Footnote </span>' + refNum);
            $ref.changeElementType('a');
        });

        $('[data-footnote]').each(function () {
            var $fn = $(this);
            var fnNum = $fn.attr('data-footnote');
            var fnHtml = $fn.html();
            $fn.attr('id', 'footnote' + fnNum);

            var fnHTMLArr;
            var splitter;
            if (/<wbr>/.test(fnHtml)) {
                fnHTMLArr = fnHtml.split('<wbr>');
                splitter = '<wbr>';
            }
            else {
                fnHTMLArr = fnHtml.split(' ');
                splitter = ' ';
            }
            var lastWord = fnHTMLArr.pop();
            fnHtml = fnHTMLArr.join(splitter);

            $fn.parent().html('<span aria-hidden="true">' + fnNum + '. </span><span class="visually-hidden">Footnote ' + fnNum + ': </span>' + fnHtml + splitter + '<span class="nobr">' + lastWord + '<a class="fn-return" href="#fnref' + fnNum + '" aria-label="Back to content">↩</a></span>').attr('id', 'footnote' + fnNum);
        });

        $('#manuscript').click(function (e) {

            var $target = $(e.target);

            // expand figure links
            if ($target.hasClass('expand-figure')) {
                e.preventDefault();
                e.stopPropagation();
                var figId = $target.attr('href').replace('#', '');
                var win = window.open('asset/figure.html?figid=' + figId, figId);
                return;
            }

            if (!($target.hasClass('fn-return')) && !($target.attr('data-fnref'))) {
                return;
            }

            console.log('caught click on footnote');

            var href = $target.attr('href');

            if ($target.hasClass('fn-return')) {
                e.preventDefault();
                e.stopPropagation();
                var $footnote = $(href);
                var $footnoteParent = $footnote.parent();
                var parentId = $footnoteParent.attr('id');
                $footnote.focus();
                document.getElementById(parentId).scrollIntoView();
                if ($footnoteParent.hasClass('highlight')) {
                    $footnoteParent.removeClass('highlight');
                    $footnoteParent.addClass('highlight2');
                }
                else {
                    $footnoteParent.removeClass('highlight2');
                    $footnoteParent.addClass('highlight');
                }
                return false;
            }
            else {
                var $href = $(href);
                if ($href.hasClass('highlight')) {
                    $href.removeClass('highlight');
                    $href.addClass('highlight2');
                }
                else {
                    $href.removeClass('highlight2');
                    $href.addClass('highlight'); 
                }
                return true;
            }
        });
    },

    getFigure: function (figId) {
        console.log('getFigure: ', figId);
        var $figure = $('#' + figId);
        if ($figure.length === 0) {
            return null;
        }
        var $img = $figure.find('img');
        return { src: $img.attr('src').replace('asset/', ''), caption: $figure.find('figcaption').html(), alt: $img.attr('alt'), title: $figure.attr('data-title') };
    }

});

var player = new Player_subtype();


Query.prototype.setError = function (errMesg) {

    var alertIcon = '<svg version="1.0" xmlns="http://www.w3.org/2000/svg" width="1280.000000pt" height="1138.000000pt" viewBox = "0 0 1280.000000 1138.000000" preserveAspectRatio="xMidYMid meet" role="image" aria-hidden="true"><g transform="translate(0.000000,1138.000000) scale(0.100000,-0.100000)" stroke="none"><path d="M6280 11374 c-14 -2 -51 -9 -83 -15 -252 -45 -510 -210 -661 -422 -24 -34 -754 -1293 -1621 -2797 -868 -1504 -2077 -3601 -2688 -4660 -611 -1059 -1125 -1959 -1142 -2000 -119 -280 -110 -601 25 -876 140 -287 381 -485 698 -572 l97 -27 5495 0 5495 0 97 27 c317 87 558 285 698 572 136 277 145 590 25 876 -17 41 -531 941 -1142 2000 -611 1059 -1820 3156 -2688 4660 -867 1504 -1597 2763 -1621 2797 -189 266 -496 428 -829 438 -71 2 -141 2 -155 -1z m137 -1086 c6 -13 330 -576 720 -1253 390 -676 1321 -2290 2068 -3585 747 -1295 1621 -2809 1941 -3365 l583 -1010 -2665 -3 c-1465 -1 -3863 -1 -5328 0 l-2665 3 289 500 c1005 1744 2443 4238 3645 6322 765 1327 1393 2412 1396 2413 3 0 10 -10 16 -22z"/><path d="M6275 7456 c-338 -64 -584 -357 -585 -694 0 -45 27 -233 70 -490 257 -1521 290 -1713 300 -1750 23 -85 111 -185 198 -225 67 -31 217 -31 284 0 87 40 175 140 198 225 5 18 39 209 75 423 36 215 86 507 110 650 187 1098 188 1105 182 1205 -14 258 -166 484 -402 596 -134 64 -294 86 -430 60z"/><path d="M6313 3549 c-415 -48 -701 -459 -603 -868 62 -257 270 -466 525 -527 90 -21 240 -21 330 0 377 90 615 478 525 855 -84 351 -416 581 -777 540z"/></g></svg>';

    $('#question_error_div_' + this.parent_question.index).html(alertIcon + errMesg).css('display', 'block');
}

Query.prototype.clearError = function () {
    $('#question_error_div_' + this.parent_question.index).html('').css('display', 'none');
}


DD_Query = DD_Query.extend({

    getHTML: function (mode) {
        var html = "";

        // DD's never have query text
        // Start a nobr tag for the item
        html = '<span class="query_dd_select_span">';

        // if we're in preview mode or 
        // (a student answer has been given and we're not in review_correct_incorrect mode), 
        // or the student got it correct
        // disable the select
        var disabled = "";
        if (mode == 'preview' || (mode != 'review_correct_incorrect' && this.user_answer_index != null) || this.isCorrect()) {
            disabled = "disabled";
        }

        var initialOption = "Choose a chapter";

        html += '<select class="query_dd_select" id="query_answer_' + this.query_index + '" ' + disabled + '>'
            + '<option value="-1">' + initialOption + '</option>'

        for (var j = 0; j < this.choices.length; ++j) {
            var index = this.choice_order[j];
            var selected = "";
            // select the student answer, unless we're in preview mode
            if (this.user_answer_index == index && mode != 'preview') {
                selected = "selected"
            }
            html += '<option value="' + index + '" ' + selected + '>' + this.choices[index] + '</option>';
        }
        html += '</select>'
        html += this.finish_inline_query(this.choices[this.correct_answer_index], mode);

        // Close off the nobr tag for the item
        html += '</span>';

        return html;
    }

});

MC_Query = MC_Query.extend({

    // This is showing duplicate feedback information, so we don't need it
    correct_incorrect_feedback: function (mode, is_correct) {
        return '';

        /*
        safe_log("correct_incorrect_feedback");

        var html = "";

        // get correct answer as presented to user
        for (var i = 0; i < this.choices.length; ++i) {
            if (this.choice_order[i] == this.correct_answer_index) {
                break;
            }
        }

        // if the question explicitly defines feedback for the user's answer, use it as the feedback
        if (this.user_answer_index !== null && this.choices_fb[this.user_answer_index] !== null) {
            html += this.choices_fb[this.user_answer_index];
        }

        // the correct answer will be highlighted in green, so there's no reason to say anything more.

        // now, if we got any feedback, enclose it in a div
        if (html !== "") {
            html = "<div class='query_mc_feedback_correct_incorrect'><p>" + html + "</p></div>";
        }

        return html;
        */
    },

    evaluateAnswer: function () {

        /*
        if (!this.user_has_answered()) {
            this.set_evaluation_feedback("You must select an answer.");
            player.setLiveText("You must select an answer.");
            return false;
        }
        */

        var parent_index = this.parent_question.index;
        $('#mc_question_evaulation_feedback_' + parent_index).remove();

        // get the user's selected answer, which will be 0-based
        this.user_answer_index = $('input:radio[name=query_answer_' + this.query_index + ']:checked').val() * 1;

        // set grade accordingly (if this.md.no_correct_answer is true, any answer is correct)
        if (this.user_answer_index == this.correct_answer_index || this.md.no_correct_answer == "true") {
            this.setGrade(100);
        }
        else {
            this.setGrade(0);
        }

        return true;
    },

    set_evaluation_feedback: function (html) {

        var parent_index = this.parent_question.index;
        var $parent = $('[data-question_index="' + parent_index + '"]');
        var $mc_eval_div = $('#mc_question_evaulation_feedback_' + parent_index);

        if ($mc_eval_div.length > 0) {
            $mc_eval_div.html(html);
        }
        else {
            html = "<div class='mc_question_evaulation_feedback' id='mc_question_evaulation_feedback_" + parent_index + "'>" + html + "</div>";
            $parent.find('#question_action_div_' + parent_index).before(html);
        }
    },

    user_has_answered: function () {

        if (typeof $('input:radio[name=query_answer_' + this.query_index + ']:checked').val() != "undefined") {
            return true;
        }
        else {
            return false;
        }
    },

    query_text_html: function () {
        var text;

        if (this.query_text !== "" && this.md._hide_query_text !== 'true') {
            text = jQuery.trim(this.query_text);
            //text = Auxiliary.underlinedText(text);

            // Replace newlines with <br />
            text = text.replace(/\n/g, ' ');

            var q_pre = "Question " + this.parent_question.index + ". ";
            if (typeof QUESTION_PREFIX === 'string') {
                q_pre = QUESTION_PREFIX;
            }
            q_pre = '<span class="visually-hidden">Question </span><strong>'
                + this.md.qnum + '.</strong > ';

            // Set id for use it to associate query text with input radios
            //if (iOS) {
                // iOS doesn't see legend
                //return '<div class="query_text">' + q_pre + text + '</div>';
            //}
            //else {
                return '<legend class="query_text">' + q_pre + text + '</legend>';
            //}
        }
        else {
            if (this.query_text == '') {
                return '<legend class="query_text"><strong class="visually-hidden">You would need to choose from two options below.</strong></legend>';
            }
            else {
                return '';
            }
        }
    },

    getHTML: function (mode) {

        // initialize imagemap elements

        if (this.imagemap_initialized === false) {
            var question_jq = this.jq.parent();
            this.im_init(question_jq);
            this.imagemap_initialized = true;
        }

        // we will add this last so we can add 'disabled' if the question
        // has been answered
        var html = "";
        var fieldset_disabled = false;
        html += this.query_text_html();

        // Build answer selection
        var is_correct = false;

        var letters = new Array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H');

        html += '<div class="mc_options">';

        for (var z = 0; z < this.choices.length; z++) {
            var index = this.choice_order[z];

            // if this is review mode...
            var checked = "";
            var disabled = "";
            var radio_style = "query_mc_other_choice";

            if (mode == 'review' || mode == 'review_correct_incorrect'
                || mode == 'preview') {

                // if it's the correct choice, it should be marked in green
                if (index == this.correct_answer_index) {
                    // but only if we're *not* in review_correct_incorrect mode or this is the user's choice
                    if (mode != 'review_correct_incorrect' || index == this.user_answer_index) {
                        radio_style = "query_mc_correct_choice";
                    }

                    // if this is what the user chose, he got it correct
                    if (index == this.user_answer_index) {
                        is_correct = true;
                    }

                    // else if it's the user's choice (and this.md.no_correct_answer is not true), it should be marked in red
                }
                else if (index == this.user_answer_index && this.md.no_correct_answer != "true") {
                    radio_style = "query_mc_incorrect_user_choice";
                }

                // and the input should be disabled, unless we're in review_correct_incorrect mode
                if (mode != "review_correct_incorrect") {
                    disabled = "disabled";
                }
            }

            // if this is the choice the user clicked, it's checked (regardless of mode)
            if (index == this.user_answer_index) {
                checked = "checked";
            }

            var mc_option_class = "";
            var mc_answer_info = "";
            var answer_info_id = " id=answer_info" + this.query_index + '_' + index;

            if (radio_style === "query_mc_correct_choice") {
                mc_option_class = " correct_answer";

                if (checked === "checked") {
                    mc_answer_info = " <span class='answer_info correct visually-hidden'"
                        + answer_info_id + "> (Your answer, correct)</span>";
                }
                else {
                    mc_answer_info = " <span class='answer_info correct visually-hidden'"
                        + answer_info_id + "> (Correct answer)</span>";
                }
            }
            else if (radio_style === "query_mc_incorrect_user_choice") {
                mc_option_class = " incorrect_answer";

                if (checked === "checked") {
                    mc_answer_info = " <span class='answer_info incorrect visually-hidden'"
                        + answer_info_id + "> (Your answer, incorrect)</span>";
                }
                else {
                    mc_answer_info = " <span class='answer_info incorrect visually-hidden'"
                        + answer_info_id + "> (Incorrect answer)</span>";
                }
            }
            // this is for questions with no correct answer
            else if (checked === "checked") {
                mc_answer_info = " <span class='visually-hidden'>(Your answer)</span>";
            }

            var aria_disabled = "";
            if (disabled === "disabled") {
                aria_disabled = " aria-disabled='true' disabled='true' ";
                fieldset_disabled = true;
            }

            var label_elem = "label";
            if (mode == "review") {
                label_elem = "label";
            }

            //if (isMac) {
            // Create radio button input plus label
            html += "<div class='mc_option" + mc_option_class + "'>"
                //+ "<span class='" + radio_style + "'>"
                + "<input class='query_mc_choice_radio' type='radio' name='query_answer_"
                + this.query_index + "' "
                + " id='query_answer_" + this.query_index + "_" + index + "' "
                + " value='" + index + "' "
                + checked + " " + disabled + aria_disabled + " "
                + " />"
                //+ "</span>"
                + "<" + label_elem + " class='label' id='query_answer_label_"
                + this.query_index + "_" + index + "'";

            html += " for='query_answer_" + this.query_index + "_" + index + "'";
            html += ">"
                //+ "<span class='letter'><span class='v-h'>Choice </span>" + letters[z]
                //+ ".</span> "
                //+ "<span class='text'>"
                + this.choices[index]
                + mc_answer_info
                //+ "</span>"
                + "</" + label_elem + " ></div > ";
            /*
            }
            else {
                html += "<div class='mc_option" + mc_option_class + "'><span class='"
                + radio_style
                + "'><input class='query_mc_choice_radio' type='radio' name='query_answer_"
                + this.query_index + "' "
                + " id='query_answer_" + this.query_index + "_" + index + "' "
                + " value='" + index + "' "
                + checked + " "
                + disabled + aria_disabled + " "
                + " />"
                + "</span>"
                + "<" + label_elem + " class='label' id='query_answer_label_"
                + this.query_index + "_" + index + "'";

                html += " for='query_answer_" + this.query_index + "_" + index + "'";
                html += ">"
                + "<span class='letter'>" + letters[z] + "</span> "
                + "<span class='text'>"
                + this.choices[index]
                + mc_answer_info
                + "</span></" + label_elem + "></div>";
            }
            */
        }

        html += "</div></fieldset>";

        if (fieldset_disabled) {
            html = "<fieldset aria-disabled='true' disabled>" + html;
        }
        else {
            html = "<fieldset>" + html;
        }

        // Add heading
        html = '<h4 class="visually-hidden">Question ' + this.md.qnum + '</h4>' + html;

        // add the question text <p> for this question
        //var q_text = this.query_text;

        // get a possible feedback string; this fn will take account of mode
        html += this.correct_incorrect_feedback(mode, is_correct);

        return html;

    }

});

Essay_Query = Essay_Query.extend({

    // this is called by question.is_complete() to determine if question has been completed
    // since we can have a min word limit for essay questions, we can't just check if the user
    // has entered text, we must check that they entered enough text to get a grade of 100
    userHasAnswered: function () {
        //return (this.user_answer != "" && this.user_answer != null);
        return (this.grade == 100);
    },

    getUserAnswerForARGA: function () {
        if (this.user_answer == null || this.user_answer == "") {
            return "Not answered";
        }
        else {
            var sanitizedAnswer = sanitizeHtml(this.user_answer, {
                allowedTags: ['br'],
                allowedAttributes: {},
                disallowedTagsMode: 'recursiveEscape'
            });
            //return this.user_answer;
            return sanitizedAnswer;
        }
    },

    query_text_html: function () {

        //return "";

        var prefix = '';
        if (this.parent_question.md.question_number) {
            prefix = '<span class="visually-hidden">Question ' + this.parent_question.md.question_number + ': </span>';
        }

        if (this.query_text != "" && this.md._hide_query_text != "true") {
            // replace newlines with <br />
            var qt = jQuery.trim(this.query_text).replace(/\n/g, "<br>")

            return "<label class='query_text' for='query_answer_"+ this.query_index + "'>" + prefix + qt + "</label>"
        } else {
            return "";
        }
    },

    getHTML: function (mode) {
        // start with the query text, if there
        var html = this.query_text_html();

        var val, disabled;
        if (!this.userHasAnswered() || mode == 'preview') {
            val = "";
            disabled = "";

            // otherwise we have an answer, so fill it in
        } else {
            // make sure we convert double quotes to &#34; for placement in 'value="xxx"' attributes
            val = this.user_answer;

            // convert breaks to newlines
            val = val.replace(/<br *(\/)?>/g, "\n");

            // also disable the input if we're not in review_correct_incorrect mode
            if (mode != "review_correct_incorrect") {
                disabled = "aria-disabled='true' readonly tabindex='-1'";
            }
        }

        html += "<textarea id='query_answer_" + this.query_index + "' class='query_essay_ta' " + disabled + ">"
            + val + "</textarea>";

        // if answer was just entered and grade is 100, also show the "provisional" message
        // (unless for this question it isn't provisional)
        if (this.answer_was_just_entered && this.grade == 100 && this.md.points_are_provisional == "true") {
            html += "<div class='essay_question_evaulation_feedback'>Your answer has been provisionally accepted. You'll get full credit for now, but your instructor may update your grade later after evaluating it.</div>";
        }

        return html;
    },

});

XRefs = XRefs.extend({

    create_links: function ($section) {
        $section.find("[data-type='link']").each(function () {
            var $link = $(this);
            var href = $link.attr('data-href');
            var html = $link.html();
            var target = $link.attr('data-target') ? ' target="' + $link.attr('data-target') + '"' : '';
            var https = $link.attr('data-https') === 'false' ? false : true;
            if (!https) {
                href = href.replace('https:', 'http:');
            }
            $link.replaceWith('<a href="' + href + '"' + target + '>' + html + '</a>');
        });
    }

});

var AriaText = {

    setLiveText: function (text) {
        var $liveTextDiv = $('#live-feedback');

        var currTime = Date.now();
        $liveTextDiv.attr('data-lasttime', currTime);
        $liveTextDiv.html('');
        $liveTextDiv.html(text);

        setTimeout(function () {
            var lastTime = $liveTextDiv.attr('data-lasttime');
            if (Number(lastTime) === currTime) {
                $liveTextDiv.html('');
            }
        }, 3000);

    },

    initLiveFeedback: function () {
        var live = 'assertive';
        var liveFeedbackDiv = $('<div id="live-feedback" class="visually-hidden" role="alert"></div>');
        $('body').append(liveFeedbackDiv);
    }

};


function formatUrl(url) {
    // Split the URL into an array to distinguish double slashes from single slashes
    var doubleSlash = url.split('//')

    // Format the strings on either side of double slashes separately
    var formatted = doubleSlash.map(str =>
        // Insert a word break opportunity after a colon
        str.replace(/(?<after>:)/giu, '$1<wbr>')
            // Before a single slash, tilde, period, comma, hyphen, underline, question mark, number sign, or percent symbol
            .replace(/(?<before>[/~,\-_?#%])/giu, '<wbr>$1')
            // Before and after an equals sign or ampersand
            .replace(/(?<beforeAndAfter>[=&])/giu, '<wbr>$1<wbr>')
        // Reconnect the strings with word break opportunities after double slashes
    ).join('//<wbr>')

    return formatted
}
